/************************************************************
Copyright 1989 by The Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation, and that the name of MIT not be used in
advertising or publicity pertaining to distribution of the
software without specific prior written permission.
M.I.T. makes no representation about the suitability of
this software for any purpose. It is provided "as is"
without any express or implied warranty.

********************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include "X.h"
#include "Xprotostr.h"
#include "miscstruct.h"
#include "gcstruct.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "cfb.h"
#include "cfbmskbits.h"
#include "mifillarc.h"

extern void miPolyFillArc();

#define ELIPSOLID(ROP) \
    while (y) \
    { \
	addrlt += nlwidth; \
	addrlb -= nlwidth; \
	if (iscircle) \
	{ \
	    MIFILLCIRCSTEP(slw); \
	} \
	else \
	{ \
	    MIFILLELLSTEP(slw); \
	    if (!slw) \
		continue; \
	} \
	xpos = xorg - x; \
	addrl = addrlt + (xpos >> PWSH); \
	if (((xpos & PIM) + slw) < PPW) \
	{ \
	    maskpartialbits(xpos, slw, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    *addrl = (*addrl & ~startmask) | \
			(ROP(cfbfgmk[plane], *addrl) & startmask); \
		} \
		addrl += dstpljmp; \
	    } \
	    if (miFillArcLower(slw)) \
	    { \
		addrl = addrlb + (xpos >> PWSH); \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			*addrl = (*addrl & ~startmask) | \
			    (ROP(cfbfgmk[plane], *addrl) & startmask); \
		    } \
		    addrl += dstpljmp; \
		} \
	    } \
	    continue; \
	} \
	maskbits(xpos, slw, startmask, endmask, nlmiddle); \
	taddr = addrl; \
	for (plane = 0; plane < depth; plane++) \
	{ \
	    if (cfbplmk[plane]) \
	    { \
		if (startmask) \
		{ \
		    *addrl = (*addrl & ~startmask) | \
			(ROP(cfbfgmk[plane], *addrl) & startmask); \
		    addrl++; \
		} \
		n = nlmiddle; \
		while (n--) \
		    *addrl++ = ROP(cfbfgmk[plane], *addrl); \
		if (endmask) \
		    *addrl = (*addrl & ~endmask) | \
			(ROP(cfbfgmk[plane], *addrl) & endmask); \
	    } \
	    taddr += dstpljmp; \
	    addrl = taddr; \
	} \
	if (!miFillArcLower(slw)) \
	    continue; \
	addrl = taddr = addrlb + (xpos >> PWSH); \
	for (plane = 0; plane < depth; plane++) \
	{ \
	    if (cfbplmk[plane]) \
	    { \
		if (startmask) \
		{ \
		    *addrl = (*addrl & ~startmask) | \
			(ROP(cfbfgmk[plane], *addrl) & startmask); \
		    addrl++; \
		} \
		n = nlmiddle; \
		while (n--) \
		    *addrl++ = ROP(cfbfgmk[plane], *addrl); \
		if (endmask) \
		    *addrl = (*addrl & ~endmask) | \
			(ROP(cfbfgmk[plane], *addrl) & endmask); \
	    } \
	    taddr += dstpljmp; \
	    addrl = taddr; \
	} \
    }

static void
cfbFillEllipseSolid(pDraw, pGC, arc)
    DrawablePtr pDraw;
    GCPtr pGC;
    xArc *arc;
{
    int iscircle;
    int x, y, e, ex;
    int yk, xk, ym, xm, dx, dy, xorg, yorg;
    miFillArcRec info;
    int *addrlt, *addrlb;
    register int *addrl;
    register int n;
    int nlwidth;
    register int xpos;
    register int slw;
    int startmask, endmask, nlmiddle;
    int rop;
    int dstpljmp;
    int depth;
    unsigned long pixel;
    unsigned long planemask;

    if (pDraw->type == DRAWABLE_WINDOW)
    {
	addrlt = (int *)
	       (((PixmapPtr)(pDraw->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
	       (((PixmapPtr)(pDraw->pScreen->devPrivate))->devKind) >> 2;
    }
    else
    {
	addrlt = (int *)(((PixmapPtr)pDraw)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDraw)->devKind) >> 2;
	dstpljmp = nlwidth * pDraw->height;
    }
    rop = pGC->alu;
    depth = pDraw->depth;
    planemask = pGC->planemask;
    pixel = pGC->fgPixel;
    miFillArcSetup(arc, &info);
    MIFILLARCSETUP();
    xorg += pDraw->x;
    yorg += pDraw->y;
    addrlb = addrlt;
    addrlt += nlwidth * (yorg - y);
    addrlb += nlwidth * (yorg + y + dy);
    iscircle = (arc->width == arc->height);
    if (pDraw->type == DRAWABLE_WINDOW)
    {
	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	while (y)
	{
	    addrlt += nlwidth;
	    addrlb -= nlwidth;
	    if (iscircle)
	    {
		MIFILLCIRCSTEP(slw);
	    }
	    else
	    {
		MIFILLELLSTEP(slw);
		if (!slw)
		    continue;
	    }
	    xpos = xorg - x;
	    addrl = addrlt + (xpos >> PWSH);
	    if (((xpos & PIM) + slw) < PPW)
	    {
		maskpartialbits(xpos, slw, startmask);
		*addrl = startmask;
		if (miFillArcLower(slw))
		{
		    addrl = addrlb + (xpos >> PWSH);
		    *addrl = startmask;
		}
		continue;
	    }
	    maskbits(xpos, slw, startmask, endmask, nlmiddle);
	    if (startmask)
	    {
		*addrl = startmask;
		addrl++;
	    }
	    n = nlmiddle;
	    Duff(n, *addrl++ = ALL_ONE);
	    if (endmask)
		*addrl = endmask;
	    if (!miFillArcLower(slw))
		continue;
	    addrl = addrlb + (xpos >> PWSH);
	    if (startmask)
	    {
		*addrl = startmask;
		addrl++;
	    }
	    n = nlmiddle;
	    Duff(n, *addrl++ = ALL_ONE);
	    if (endmask)
		*addrl = endmask;
	}
    }
    else
    {
	int plane, *taddr;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	}

	switch(rop)
	{
	    case GXcopy:
		ELIPSOLID(fnCOPY);
		break;
	    case GXxor:
		ELIPSOLID(fnXOR);
		break;
	    case GXand:
		ELIPSOLID(fnAND);
		break;
	    case GXor:
		ELIPSOLID(fnOR);
		break;
	    case GXset:
		ELIPSOLID(fnSET);
		break;
	    case GXclear:
		ELIPSOLID(fnCLEAR);
		break;
	    case GXandReverse:
		ELIPSOLID(fnANDREVERSE);
		break;
	    case GXandInverted:
		ELIPSOLID(fnANDINVERTED);
		break;
	    case GXnor:
		ELIPSOLID(fnNOR);
		break;
	    case GXequiv:
		ELIPSOLID(fnEQUIV);
		break;
	    case GXinvert:
		ELIPSOLID(fnINVERT);
		break;
	    case GXorReverse:
		ELIPSOLID(fnORREVERSE);
		break;
	    case GXcopyInverted:
		ELIPSOLID(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		ELIPSOLID(fnORINVERTED);
		break;
	    case GXnand:
		ELIPSOLID(fnNAND);
		break;
	    default:
		break;
	}
    }
}

#define FILLSPAN_W(xl,xr,addr) \
    if (xr >= xl) \
    { \
	width = xr - xl + 1; \
	addrl = addr + (xl >> PWSH); \
	if (((xl & PIM) + width) <= PPW) \
	{ \
	    maskpartialbits(xl, width, startmask); \
	    *addrl = startmask; \
	} \
	else \
	{ \
	    maskbits(xl, width, startmask, endmask, n); \
	    if (startmask) \
	    { \
		*addrl = startmask; \
		addrl++; \
	    } \
	    Duff(n, *addrl++ = ALL_ONE); \
	    if (endmask) \
		*addrl = endmask; \
	} \
    }

#define FILLSPAN_P(xl,xr,addr, ROP) \
    if (xr >= xl) \
    { \
	width = xr - xl + 1; \
	addrl = addr + (xl >> PWSH); \
	if (((xl & PIM) + width) < PPW) \
	{ \
	    maskpartialbits(xl, width, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    *addrl = (*addrl & ~startmask) | \
			(ROP(cfbfgmk[plane], *addrl) & startmask); \
		} \
		addrl += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(xl, width, startmask, endmask, nlmiddle); \
	    taddr = addrl; \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    if (startmask) \
		    { \
			*addrl = (*addrl & ~startmask) | \
			    (ROP(cfbfgmk[plane], *addrl) & startmask); \
			addrl++; \
		    } \
		    n = nlmiddle; \
		    while (n--) \
			*addrl++ = ROP(cfbfgmk[plane], *addrl); \
		    if (endmask) \
			*addrl = (*addrl & ~endmask) | \
			    (ROP(cfbfgmk[plane], *addrl) & endmask); \
		} \
		taddr += dstpljmp; \
		addrl = taddr; \
	    } \
	} \
    }

#define FILLSLICESPANS_W(flip,addr) \
    if (!flip) \
    { \
	FILLSPAN_W(xl, xr, addr); \
    } \
    else \
    { \
	xc = xorg - x; \
	FILLSPAN_W(xc, xr, addr); \
	xc += slw - 1; \
	FILLSPAN_W(xl, xc, addr); \
    }

#define FILLSLICESPANS_P(flip,addr, ROP) \
    if (!flip) \
    { \
	FILLSPAN_P(xl, xr, addr, ROP); \
    } \
    else \
    { \
	xc = xorg - x; \
	FILLSPAN_P(xc, xr, addr, ROP); \
	xc += slw - 1; \
	FILLSPAN_P(xl, xc, addr, ROP); \
    }

#define SLICESOLID(ROP) \
    while (y > 0) \
    { \
	addrlt += nlwidth; \
	addrlb -= nlwidth; \
	if (iscircle) \
	{ \
	    MIFILLCIRCSTEP(slw); \
	} \
	else \
	{ \
	    MIFILLELLSTEP(slw); \
	} \
	MIARCSLICESTEP(slice.edge1); \
	MIARCSLICESTEP(slice.edge2); \
	if (miFillSliceUpper(slice)) \
	{ \
	    MIARCSLICEUPPER(xl, xr, slice, slw); \
	    FILLSLICESPANS_P(slice.flip_top, addrlt, ROP); \
	} \
	if (miFillSliceLower(slice)) \
	{ \
	    MIARCSLICELOWER(xl, xr, slice, slw); \
	    FILLSLICESPANS_P(slice.flip_bot, addrlb, ROP); \
	} \
    }

static void
cfbFillArcSliceSolid(pDraw, pGC, arc)
    DrawablePtr pDraw;
    GCPtr pGC;
    xArc *arc;
{
    int yk, xk, ym, xm, dx, dy, xorg, yorg, slw;
    register int x, y, e, ex;
    miFillArcRec info;
    miArcSliceRec slice;
    int xl, xr, xc;
    int iscircle;
    int *addrlt, *addrlb;
    register int *addrl;
    register int n;
    int nlmiddle;
    int nlwidth;
    int startmask, endmask;
    int rop;
    int dstpljmp;
    int depth;
    int width;
    unsigned long pixel;
    unsigned long planemask;

    if (pDraw->type == DRAWABLE_WINDOW)
    {
	addrlt = (int *)
	       (((PixmapPtr)(pDraw->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
	       (((PixmapPtr)(pDraw->pScreen->devPrivate))->devKind) >> 2;
    }
    else
    {
	addrlt = (int *)(((PixmapPtr)pDraw)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDraw)->devKind) >> 2;
	dstpljmp = nlwidth * pDraw->height;
    }
    rop = pGC->alu;
    depth = pDraw->depth;
    planemask = pGC->planemask;
    pixel = pGC->fgPixel;
    miFillArcSetup(arc, &info);
    miFillArcSliceSetup(arc, &slice, pGC);
    MIFILLARCSETUP();
    iscircle = (arc->width == arc->height);
    xorg += pDraw->x;
    yorg += pDraw->y;
    addrlb = addrlt;
    addrlt += nlwidth * (yorg - y);
    addrlb += nlwidth * (yorg + y + dy);
    slice.edge1.x += pDraw->x;
    slice.edge2.x += pDraw->x;
    if (pDraw->type == DRAWABLE_WINDOW)
    {
	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	while (y > 0)
	{
	    addrlt += nlwidth;
	    addrlb -= nlwidth;
	    if (iscircle)
	    {
		MIFILLCIRCSTEP(slw);
	    }
	    else
	    {
		MIFILLELLSTEP(slw);
	    }
	    MIARCSLICESTEP(slice.edge1);
	    MIARCSLICESTEP(slice.edge2);
	    if (miFillSliceUpper(slice))
	    {
		MIARCSLICEUPPER(xl, xr, slice, slw);
		FILLSLICESPANS_W(slice.flip_top, addrlt);
	    }
	    if (miFillSliceLower(slice))
	    {
		MIARCSLICELOWER(xl, xr, slice, slw);
		FILLSLICESPANS_W(slice.flip_bot, addrlb);
	    }
	}
    }
    else
    {
	int plane, *taddr;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	}

	switch(rop)
	{
	    case GXcopy:
		SLICESOLID(fnCOPY);
		break;
	    case GXxor:
		SLICESOLID(fnXOR);
		break;
	    case GXand:
		SLICESOLID(fnAND);
		break;
	    case GXor:
		SLICESOLID(fnOR);
		break;
	    case GXset:
		SLICESOLID(fnSET);
		break;
	    case GXclear:
		SLICESOLID(fnCLEAR);
		break;
	    case GXandReverse:
		SLICESOLID(fnANDREVERSE);
		break;
	    case GXandInverted:
		SLICESOLID(fnANDINVERTED);
		break;
	    case GXnor:
		SLICESOLID(fnNOR);
		break;
	    case GXequiv:
		SLICESOLID(fnEQUIV);
		break;
	    case GXinvert:
		SLICESOLID(fnINVERT);
		break;
	    case GXorReverse:
		SLICESOLID(fnORREVERSE);
		break;
	    case GXcopyInverted:
		SLICESOLID(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		SLICESOLID(fnORINVERTED);
		break;
	    case GXnand:
		SLICESOLID(fnNAND);
		break;
	    default:
		break;
	}
    }
}

void
cfbPolyFillArcSolid(pDraw, pGC, narcs, parcs)
    DrawablePtr	pDraw;
    GCPtr	pGC;
    int		narcs;
    xArc	*parcs;
{
    register xArc *arc;
    register int i;
    BoxRec box;
    RegionPtr cclip;

    if (!(pGC->planemask) || pGC->alu == GXnoop)
	return;

    cclip = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip;
    for (arc = parcs, i = narcs; --i >= 0; arc++)
    {
	if (miFillArcEmpty(arc))
	    continue;
	if (miCanFillArc(arc))
	{
	    box.x1 = arc->x + pDraw->x;
	    box.y1 = arc->y + pDraw->y;
	    box.x2 = box.x1 + (int)arc->width + 1;
	    box.y2 = box.y1 + (int)arc->height + 1;
	    if ((*pDraw->pScreen->RectIn)(cclip, &box) == rgnIN)
	    {
		if ((arc->angle2 >= FULLCIRCLE) ||
		    (arc->angle2 <= -FULLCIRCLE))
		    cfbFillEllipseSolid(pDraw, pGC, arc);
		else
		    cfbFillArcSliceSolid(pDraw, pGC, arc);
		continue;
	    }
	}
	miPolyFillArc(pDraw, pGC, 1, arc);
    }
}
