/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

/*
 * Fill rectangles.  Used by both PolyFillRect and PaintWindow.
 */

#include "X.h"
#include "Xmd.h"
#include "servermd.h"
#include "gcstruct.h"
#include "window.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "windowstr.h"

#include "cfb.h"
#include "cfbmskbits.h"

#define BOXSOLID(ROP) \
    for (; nBox; nBox--, pBox++) \
    { \
    	pdstRect = pdstBase + pBox->y1 * widthDst + (pBox->x1 >> PWSH); \
    	height = pBox->y2 - pBox->y1; \
	w = pBox->x2 - pBox->x1; \
	if ((pBox->x1 & PIM) + w < PPW) \
	{ \
	    maskpartialbits(pBox->x1, w, leftMask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    pdst = pdstRect; h = height; \
		    while(h--) \
		    { \
			*pdst = ((ROP(cfbfgmk[plane], *pdst) & leftMask) | \
				(*pdst & ~leftMask)); \
			pdst += widthDst; \
		    } \
		} \
		pdstRect += pljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits (pBox->x1, w, leftMask, rightMask, nmiddle); \
	    nlwExtra = widthDst - nmiddle; \
	    if (leftMask && rightMask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = pdstRect; h = height; \
			while(h--) \
			{ \
			    *pdst = ((ROP(cfbfgmk[plane], *pdst) & leftMask) | \
				    (*pdst & ~leftMask)); \
			    pdst++; \
			    nlw = nmiddle; \
			    while (nlw--) \
				*pdst++ = ROP(cfbfgmk[plane], *pdst); \
			    *pdst = ((ROP(cfbfgmk[plane], *pdst) & rightMask) | \
				    (*pdst & ~rightMask)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    pdstRect += pljmp; \
		} \
	    } \
	    else if (leftMask && !rightMask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = pdstRect; h = height; \
			while(h--) \
			{ \
			    *pdst = ((ROP(cfbfgmk[plane], *pdst) & leftMask) | \
				    (*pdst & ~leftMask)); \
			    pdst++; \
			    nlw = nmiddle; \
			    while (nlw--) \
				*pdst++ = ROP(cfbfgmk[plane], *pdst); \
			    pdst += nlwExtra; \
			} \
		    } \
		    pdstRect += pljmp; \
		} \
	    } \
	    else if (!leftMask && rightMask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = pdstRect; h = height; \
			while(h--) \
			{ \
			    nlw = nmiddle; \
			    while (nlw--) \
				*pdst++ = ROP(cfbfgmk[plane], *pdst); \
			    *pdst = ((ROP(cfbfgmk[plane], *pdst) & rightMask) | \
				    (*pdst & ~rightMask)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    pdstRect += pljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = pdstRect; h = height; \
			while(h--) \
			{ \
			    nlw = nmiddle; \
			    while (nlw--) \
				*pdst++ = ROP(cfbfgmk[plane], *pdst); \
			    pdst += nlwExtra; \
			} \
		    } \
		    pdstRect += pljmp; \
		} \
	    } \
	} \
    }

void
cfbFillBoxSolid (pDrawable, pGC, nBox, pBox, pixel, isCopy)
    DrawablePtr	    pDrawable;
    GCPtr	    pGC;
    int		    nBox;
    BoxPtr	    pBox;
    unsigned long   pixel;
    Bool	    isCopy;
{
    int		    *pdstBase, *pdstRect;
    int		    widthDst;
    register int    h;
    int		    rop;
    register int    *pdst;
    register unsigned long   leftMask, rightMask;
    unsigned long   planemask;
    int		    nmiddle;
    register int    nlw;
    int		    w;
    int		    depth;
    OmronFbInfoPtr  fbInfo;
    int drawFbFlag;

    if (isCopy)
    {
	planemask = ALL_ONE;
	rop = GXcopy;
    }
    else
    {
	if (pGC->alu == GXnoop || pGC->planemask == 0)
	    return;

	planemask = pGC->planemask;
	rop = pGC->alu;
    }

    depth = pDrawable->depth;

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pdstBase = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	widthDst = (int)
		  (((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;
	drawFbFlag = TRUE;
    }
    else
    {
	pdstBase = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	widthDst = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( pdstBase, fbInfo ))
	    drawFbFlag = TRUE;
	else
	    drawFbFlag = FALSE;
    }

    if (drawFbFlag == TRUE)
    {
	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	for (; nBox; nBox--, pBox++)
	{
	    pdstRect = pdstBase + pBox->y1 * widthDst + (pBox->x1 >> PWSH);
	    h = pBox->y2 - pBox->y1;
	    w = pBox->x2 - pBox->x1;
	    if ((pBox->x1 & PIM) + w < PPW)
	    {
		maskpartialbits(pBox->x1, w, leftMask);
		pdst = pdstRect;
		while (h--) {
		    *pdst = leftMask;
		    pdst += widthDst;
		}
	    }
	    else
	    {
		maskbits (pBox->x1, w, leftMask, rightMask, nmiddle);
		while (h--) {
		    pdst = pdstRect;
		    if (leftMask)
		    {
			*pdst = leftMask;
			pdst++;
		    }
		    nlw = nmiddle;
		    Duff(nlw, *pdst++ = ALL_ONE);
		    if (rightMask)
			*pdst = rightMask;
		    pdstRect += widthDst;
		}
	    }
	}
    }
    else
    {
	register int plane;
	int height, pljmp, nlwExtra;
	
	pljmp = widthDst * pDrawable->height;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	}

	switch(rop)
	{
	    case GXcopy:
		BOXSOLID(fnCOPY);
		break;
	    case GXxor:
		BOXSOLID(fnXOR);
		break;
	    case GXand:
		BOXSOLID(fnAND);
		break;
	    case GXor:
		BOXSOLID(fnOR);
		break;
	    case GXset:
		BOXSOLID(fnSET);
		break;
	    case GXclear:
		BOXSOLID(fnCLEAR);
		break;
	    case GXandReverse:
		BOXSOLID(fnANDREVERSE);
		break;
	    case GXandInverted:
		BOXSOLID(fnANDINVERTED);
		break;
	    case GXnor:
		BOXSOLID(fnNOR);
		break;
	    case GXequiv:
		BOXSOLID(fnEQUIV);
		break;
	    case GXinvert:
		BOXSOLID(fnINVERT);
		break;
	    case GXorReverse:
		BOXSOLID(fnORREVERSE);
		break;
	    case GXcopyInverted:
		BOXSOLID(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		BOXSOLID(fnORINVERTED);
		break;
	    case GXnand:
		BOXSOLID(fnNAND);
		break;
	    default:
		break;
	}
    }
}

#define BOXTILE32(ROP) \
    while (nBox--) \
    { \
	w = pBox->x2 - pBox->x1; \
	height = pBox->y2 - pBox->y1; \
	y = pBox->y1; \
	Pdst = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH); \
	srcy = y % tileHeight; \
	Psrc = psrc; \
	if ( ((pBox->x1 & PIM) + w) < PPW) \
	{ \
	    maskpartialbits(pBox->x1, w, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    iy = srcy; h = height; \
		    p = Pdst; \
		    while (h--) \
		    { \
			srcpix = Psrc[iy]; \
			++iy; \
			if (iy == tileHeight) \
			    iy = 0; \
			*p = (ROP(srcpix, *p) & startmask) | \
				(*p & ~startmask); \
			p += nlwDst; \
		    } \
		} \
		Psrc += srcpljmp; \
		Pdst += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(pBox->x1, w, startmask, endmask, nlwMiddle); \
	    nlwExtra = nlwDst - nlwMiddle; \
	    if (startmask && endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			iy = srcy; h = height; \
			p = Pdst; \
			while (h--) \
			{ \
			    srcpix = Psrc[iy]; \
			    ++iy; \
			    if (iy == tileHeight) \
				iy = 0; \
			    nlw = nlwMiddle; \
			    *p = (ROP(srcpix, *p) & startmask) | \
				(*p & ~startmask); \
			    p++; \
			    Duff(nlw, *p++ = ROP(srcpix,*p)); \
			    *p = (ROP(srcpix, *p) & endmask) | \
				(*p & ~endmask); \
			    p += nlwExtra; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			iy = srcy; h = height; \
			p = Pdst; \
			while (h--) \
			{ \
			    srcpix = Psrc[iy]; \
			    ++iy; \
			    if (iy == tileHeight) \
				iy = 0; \
			    nlw = nlwMiddle; \
			    *p = (ROP(srcpix, *p) & startmask) | \
				(*p & ~startmask); \
			    p++; \
			    Duff(nlw, *p++ = ROP(srcpix,*p)); \
			    p += nlwExtra; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			iy = srcy; h = height; \
			p = Pdst; \
			while (h--) \
			{ \
			    srcpix = Psrc[iy]; \
			    ++iy; \
			    if (iy == tileHeight) \
				iy = 0; \
			    nlw = nlwMiddle; \
			    Duff(nlw, *p++ = ROP(srcpix,*p)); \
			    *p = (ROP(srcpix, *p) & endmask) | \
				(*p & ~endmask); \
			    p += nlwExtra; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			iy = srcy; h = height; \
			p = Pdst; \
			while (h--) \
			{ \
			    srcpix = Psrc[iy]; \
			    ++iy; \
			    if (iy == tileHeight) \
				iy = 0; \
			    nlw = nlwMiddle; \
			    Duff(nlw, *p++ = ROP(srcpix,*p)); \
			    p += nlwExtra; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	} \
	pBox++; \
    }

void
cfbFillBoxTile32 (pDrawable, pGC, nBox, pBox, tile, isCopy)
    DrawablePtr	    pDrawable;
    GCPtr	    pGC;
    int		    nBox;	/* number of boxes to fill */
    BoxPtr 	    pBox;	/* pointer to list of boxes to fill */
    PixmapPtr	    tile;	/* rotated, expanded tile */
    Bool	    isCopy;
{
    register unsigned int srcpix;	
    int *psrc;		/* pointer to bits in tile, if needed */
    int tileHeight;	/* height of the tile */

    int nlwDst;		/* width in longwords of the dest pixmap */
    int w;		/* width of current box */
    register int h;	/* height of current box */
    register unsigned long startmask;
    register unsigned long endmask; /* masks for reggedy bits at either end of line */
    int nlwMiddle;	/* number of longwords between sides of boxes */
    int nlwExtra;	/* to get from right of box to left of next span */
    register int nlw;	/* loop version of nlwMiddle */
    register int *p;	/* pointer to bits we're writing */
    int y;		/* current scan line */
    int srcy;		/* current tile position */
    int iy, rop;
    int depth, height;
    register int plane;
    int srcpljmp, dstpljmp;
    register int *Psrc, *Pdst;
    int *pbits;		/* pointer to start of pixmap */
    unsigned long planemask;
    OmronFbInfoPtr fbInfo;

    if (isCopy)
    {
	planemask = ALL_ONE;
	rop = GXcopy;
    }
    else
    {
	if (pGC->alu == GXnoop || pGC->planemask == 0)
	    return;

	planemask = pGC->planemask;
	rop = pGC->alu;
    }

    depth = pDrawable->depth;
    tileHeight = tile->drawable.height;
    psrc = (int *)tile->devPrivate.ptr;
    srcpljmp = (tile->devKind >> 2) * tileHeight;

    for (plane = 0; plane < depth; plane++)
    {
	cfbplmk[plane] = (planemask >> plane) & 0x1;
    }

    fbInfo = getOmronFbInfo(pDrawable);

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pbits = (int *)getPlaneAddres(fbInfo);
	nlwDst = (int)
		  (((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;
	dstpljmp = getFbPlaneLongSize();

	sx_plane_select(planemask);

	while (nBox--)
	{
	    w = pBox->x2 - pBox->x1;
	    height = pBox->y2 - pBox->y1;
	    y = pBox->y1;
	    Pdst = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH);
	    srcy = y % tileHeight;
	    Psrc = psrc;

	    if ( ((pBox->x1 & PIM) + w) < PPW)
	    {
		maskpartialbits(pBox->x1, w, startmask);
		sx_set_op(rop, startmask);
		for (plane = 0; plane < depth; plane++)
		{
		    if (cfbplmk[plane])
		    {
			iy = srcy; h = height;
			p = Pdst;
			while (h--)
			{
			    srcpix = Psrc[iy];
			    ++iy;
			    if (iy == tileHeight)
				iy = 0;
			    *p = srcpix;
			    p += nlwDst;
			}
		    }
		    Pdst += dstpljmp;
		    Psrc += srcpljmp;
		}
	    }
	    else
	    {
		maskbits(pBox->x1, w, startmask, endmask, nlwMiddle);
		nlwExtra = nlwDst - nlwMiddle;

		if (startmask && endmask)
		{
		    nlwExtra -= 1;
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    iy = srcy; h = height;
			    p = Pdst;
			    while (h--)
			    {
				srcpix = Psrc[iy];
				++iy;
				if (iy == tileHeight)
				    iy = 0;
				nlw = nlwMiddle;
				sx_set_op(rop, startmask);
				*p = srcpix;
				p++;
				sx_set_op(rop, ALL_ONE);
				Duff(nlw, *p++ = srcpix);
				sx_set_op(rop, endmask);
				*p = srcpix;
				p += nlwExtra;
			    }
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else if (startmask && !endmask)
		{
		    nlwExtra -= 1;
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    iy = srcy; h = height;
			    p = Pdst;
			    while (h--)
			    {
				srcpix = Psrc[iy];
				++iy;
				if (iy == tileHeight)
				    iy = 0;
				nlw = nlwMiddle;
				sx_set_op(rop, startmask);
				*p = srcpix;
				p++;
				sx_set_op(rop, ALL_ONE);
				Duff(nlw, *p++ = srcpix);
				p += nlwExtra;
			    }
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else if (!startmask && endmask)
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    iy = srcy; h = height;
			    p = Pdst;
			    while (h--)
			    {
				srcpix = Psrc[iy];
				++iy;
				if (iy == tileHeight)
				    iy = 0;
				nlw = nlwMiddle;
				sx_set_op(rop, ALL_ONE);
				Duff(nlw, *p++ = srcpix);
				sx_set_op(rop, endmask);
				*p = srcpix;
				p += nlwExtra;
			    }
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    iy = srcy; h = height;
			    p = Pdst;
			    while (h--)
			    {
				srcpix = Psrc[iy];
				++iy;
				if (iy == tileHeight)
				    iy = 0;
				nlw = nlwMiddle;
				sx_set_op(rop, ALL_ONE);
				Duff(nlw, *p++ = srcpix);
				p += nlwExtra;
			    }
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
	    }
	    pBox++;
	}
    }
    else
    {
	pbits = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwDst = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	if(isCommonPlane( pbits, fbInfo ))
	{
	    pbits = (int *)getPlaneAddres(fbInfo);
	    sx_set_operation_all(GXcopy,~0)
	}

	dstpljmp = nlwDst * pDrawable->height;

	switch(rop)
	{
	    case GXcopy:
		BOXTILE32(fnCOPY);
		break;
	    case GXxor:
		BOXTILE32(fnXOR);
		break;
	    case GXand:
		BOXTILE32(fnAND);
		break;
	    case GXor:
		BOXTILE32(fnOR);
		break;
	    case GXset:
		BOXTILE32(fnSET);
		break;
	    case GXclear:
		BOXTILE32(fnCLEAR);
		break;
	    case GXandReverse:
		BOXTILE32(fnANDREVERSE);
		break;
	    case GXandInverted:
		BOXTILE32(fnANDINVERTED);
		break;
	    case GXnor:
		BOXTILE32(fnNOR);
		break;
	    case GXequiv:
		BOXTILE32(fnEQUIV);
		break;
	    case GXinvert:
		BOXTILE32(fnINVERT);
		break;
	    case GXorReverse:
		BOXTILE32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		BOXTILE32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		BOXTILE32(fnORINVERTED);
		break;
	    case GXnand:
		BOXTILE32(fnNAND);
		break;
	    default:
		break;
	}
    }
}

void
cfbPolyFillRect(pDrawable, pGC, nrectFill, prectInit)
    DrawablePtr pDrawable;
    register GCPtr pGC;
    int		nrectFill; 	/* number of rectangles to fill */
    xRectangle	*prectInit;  	/* Pointer to first rectangle to fill */
{
    int xorg, yorg;
    register int n;		/* spare counter */
    xRectangle *prect;		/* temporary */
    RegionPtr prgnClip;
    register BoxPtr pbox;	/* used to clip with */
    register BoxPtr pboxClipped;
    BoxPtr pboxClippedBase;
    BoxPtr pextent;
    cfbPrivGC	*priv;
    int numRects;
    Pixel pixel;
    PixmapPtr	pRoTile;
    PixmapPtr	pTile;
    int		rgnResult;

    priv = (cfbPrivGC *) pGC->devPrivates[cfbGCPrivateIndex].ptr;
    prgnClip = priv->pCompositeClip;

    switch (pGC->fillStyle)
    {
    case FillSolid:
	pixel = pGC->fgPixel;
	break;
    case FillTiled:
	pRoTile = ((cfbPrivGCPtr) pGC->devPrivates[cfbGCPrivateIndex].ptr)->
							pRotatedPixmap;
	if (!pRoTile)
	{
	    pTile = pGC->tile.pixmap;
	}
	break;
    case FillStippled:
    case FillOpaqueStippled:
	pRoTile = ((cfbPrivGCPtr) pGC->devPrivates[cfbGCPrivateIndex].ptr)->
							pRotatedPixmap;
	if (!pRoTile)
	{
	    pTile = pGC->stipple;
	}
	break;
    }
    prect = prectInit;
    xorg = pDrawable->x;
    yorg = pDrawable->y;
    if (xorg || yorg)
    {
	prect = prectInit;
	n = nrectFill;
	while(n--)
	{
	    prect->x += xorg;
	    prect->y += yorg;
	    prect++;
	}
    }

    prect = prectInit;

    pextent = (*pGC->pScreen->RegionExtents)(prgnClip);

    while (nrectFill--)
    {
	BoxRec box;
	int	x2, y2;

	/*
	 * clip the box to the extent of the region --
	 * avoids overflowing shorts and minimizes other
	 * computations
	 */

	box.x1 = prect->x;
	if (box.x1 < pextent->x1)
		box.x1 = pextent->x1;

	box.y1 = prect->y;
	if (box.y1 < pextent->y1)
		box.y1 = pextent->y1;

	x2 = (int) prect->x + (int) prect->width;
	if (x2 > pextent->x2)
		x2 = pextent->x2;
	box.x2 = x2;

	y2 = (int) prect->y + (int) prect->height;
	if (y2 > pextent->y2)
		y2 = pextent->y2;
	box.y2 = y2;

	prect++;

	if ((box.x1 >= box.x2) || (box.y1 >= box.y2))
	    continue;

	if (REGION_NUM_RECTS (prgnClip) == 1 ||
	    (rgnResult = (*pGC->pScreen->RectIn)(prgnClip, &box)) == rgnIN)
	{
	    switch (pGC->fillStyle)
	    {
	    case FillSolid:
		cfbFillBoxSolid (pDrawable, pGC, 1, &box, pixel, FALSE);
		break;
	    case FillTiled:
		if (pRoTile)
		    cfbFillBoxTile32 (pDrawable, pGC, 1, &box, pRoTile, FALSE);
		else
		    cfbFillBoxTileOdd (pDrawable, pGC, 1, &box, pTile, FALSE);
		break;
	    case FillStippled:
		if (pRoTile)
		    cfbFillBoxStipple32 (pDrawable, pGC, 1, &box, pRoTile);
		else
		    cfbFillBoxStippleOdd(pDrawable, pGC, 1, &box, pTile);
		break;
	    case FillOpaqueStippled:
		if (pRoTile)
		    cfbFillBoxOpStip32 (pDrawable, pGC, 1, &box, pRoTile);
		else
		{
		    if (pGC->alu == GXcopy)
			cfbFillBoxOpStipOddCopy(pDrawable, pGC, 1, &box, pTile);
		    else
			cfbFillBoxOpStipOdd(pDrawable, pGC, 1, &box, pTile);
		}
		break;
	    }
	} 
	else if (rgnResult == rgnPART)
	{
	    numRects = REGION_NUM_RECTS(prgnClip);
	    pboxClippedBase = (BoxPtr)ALLOCATE_LOCAL(numRects * sizeof(BoxRec));

	    if (!pboxClippedBase)
		return;

	    pboxClipped = pboxClippedBase;
	    pbox = REGION_RECTS(prgnClip);
	    n = numRects;

	    /* clip the rectangle to each box in the clip region
	       this is logically equivalent to calling Intersect()
	    */
	    while(n--)
	    {
		pboxClipped->x1 = max(box.x1, pbox->x1);
		pboxClipped->y1 = max(box.y1, pbox->y1);
		pboxClipped->x2 = min(box.x2, pbox->x2);
		pboxClipped->y2 = min(box.y2, pbox->y2);
		pbox++;

		/* see if clipping left anything */
		if(pboxClipped->x1 < pboxClipped->x2 && 
		   pboxClipped->y1 < pboxClipped->y2)
		{
		    pboxClipped++;
		}
	    }
	    switch (pGC->fillStyle)
	    {
	    case FillSolid:
		cfbFillBoxSolid (pDrawable, pGC,
				 pboxClipped-pboxClippedBase,
				 pboxClippedBase, pixel, FALSE);
		break;
	    case FillTiled:
		if (pRoTile)
		    cfbFillBoxTile32 (pDrawable, pGC,
				      pboxClipped-pboxClippedBase,
				      pboxClippedBase, pRoTile, FALSE);
		else
		    cfbFillBoxTileOdd (pDrawable, pGC,
				       pboxClipped-pboxClippedBase,
				      pboxClippedBase, pTile, FALSE);
		break;
	    case FillStippled:
		if (pRoTile)
		    cfbFillBoxStipple32 (pDrawable, pGC,
			pboxClipped-pboxClippedBase, pboxClippedBase,
			pRoTile);
		else
		    cfbFillBoxStippleOdd (pDrawable, pGC,
			pboxClipped-pboxClippedBase, pboxClippedBase,
			pTile);
		break;
	    case FillOpaqueStippled:
		if (pRoTile)
		    cfbFillBoxOpStip32 (pDrawable, pGC,
			pboxClipped-pboxClippedBase, pboxClippedBase,
			pRoTile);
		else
		{
		    if (pGC->alu == GXcopy)
			cfbFillBoxOpStipOddCopy (pDrawable, pGC,
			    pboxClipped-pboxClippedBase, pboxClippedBase,
			    pTile);
		    else
			cfbFillBoxOpStipOdd (pDrawable, pGC,
			    pboxClipped-pboxClippedBase, pboxClippedBase,
			    pTile);
		}
		break;
	    }
	    DEALLOCATE_LOCAL(pboxClippedBase);
	}
    }
}
