/************************************************************
Copyright 1987 by Sun Microsystems, Inc. Mountain View, CA.

                    All Rights Reserved

Permission  to  use,  copy,  modify,  and  distribute   this
software  and  its documentation for any purpose and without
fee is hereby granted, provided that the above copyright no-
tice  appear  in all copies and that both that copyright no-
tice and this permission notice appear in  supporting  docu-
mentation,  and  that the names of Sun or MIT not be used in
advertising or publicity pertaining to distribution  of  the
software  without specific prior written permission. Sun and
M.I.T. make no representations about the suitability of this
software for any purpose. It is provided "as is" without any
express or implied warranty.

SUN DISCLAIMS ALL WARRANTIES WITH REGARD TO  THIS  SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
NESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL SUN BE  LI-
ABLE  FOR  ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,  DATA  OR
PROFITS,  WHETHER  IN  AN  ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION  WITH
THE USE OR PERFORMANCE OF THIS SOFTWARE.

********************************************************/

/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

extern int cfbstarttab[];
extern int cfbendtab[];
extern int cfbstartpartial[];
extern int cfbendpartial[];
extern int cfbrmask[];
extern int cfbmask[];
extern unsigned char cfbplmk[];
extern unsigned long cfbfgmk[];
extern unsigned long cfbbgmk[];
extern unsigned long cfbplbit[];
extern int cfbploff[];
extern unsigned cfbpartmasks[32][32];
extern unsigned int QuartetBitsTable[];
extern unsigned int QuartetPixelMaskTable[];

#define PPW	32
#define PLST	31
#define PIM	0x1f
#define PWSH	5

#define ALL_ONE  0xFFFFFFFF
#define ALL_ZERO 0x0

#include	"X.h"
#include	"Xmd.h"
#include	"servermd.h"
#if	(BITMAP_BIT_ORDER == MSBFirst)
#define SCRRIGHT(lw,n)	((lw) >> (n))
#define SCRLEFT(lw,n)	((lw) << (n))
#else	/* (BITMAP_BIT_ORDER == LSBFirst) */
#define SCRRIGHT(lw,n)	((lw) << (n))
#define SCRLEFT(lw,n)	((lw) >> (n))
#endif	/* (BITMAP_BIT_ORDER == MSBFirst) */

#define BitOn(src) (src)

#define BitOff(src) (~src)

#define maskbits(x, w, startmask, endmask, nlw) \
    startmask = cfbstarttab[(x)&PIM]; \
    endmask = cfbendtab[((x)+(w)) & PIM]; \
    if (startmask) \
	nlw = (((w) - (PPW - ((x)&PIM))) >> PWSH); \
    else \
	nlw = (w) >> PWSH;

#define maskpartialbits(x, w, mask) \
    mask = cfbpartmasks[(x) & PIM][(w) & PIM];

#define mask32bits(x, w, startmask, endmask) \
    startmask = cfbstarttab[(x)&PIM]; \
    endmask = cfbendtab[((x)+(w)) & PIM];


#ifdef __GNUC__
#ifdef mc68020
#define FASTGETBITS(psrc, x, w, dst) \
    asm ("bfextu %3{%1:%2},%0" \
    : "=d" (dst) : "di" (x), "di" (w), "o" (*(char *)(psrc)))

#define getbits(psrc,x,w,dst) \
{ \
    FASTGETBITS(psrc, x, w, dst);\
    dst = SCRLEFT(dst,(32-(w))); \
}

#define FASTPUTBITS(src, x, w, pdst) \
    asm ("bfins %3,%0{%1:%2}" \
	: "=o" (*(char *)(pdst)) \
	: "di" (x), "di" (w), "d" (src), "0" (*(char *)(pdst)))

#define putbits(src, x, w, pdst) \
    FASTPUTBITS(SCRRIGHT((unsigned) (src),32-(w)), x, w, pdst)

#define opaqpbits(src, x, w, pdst, poff, depth) \
{ \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    t1 = SCRRIGHT((unsigned) (src),32-(w)); \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    t2 = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
	    FASTPUTBITS(t2, x, w, tdst); \
	} \
	tdst += poff; \
    } \
}

#define tilepbits(psrc, x, w, pdst, poff, soff, depth) \
{ \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    FASTPUTBITS(SCRRIGHT((unsigned) *(tsrc),32-(w)), x, w, tdst); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define _PUTBITS(src, x, w, pdst) \
    putbits(src, x, w, pdst)

#define _TILEPBITS(psrc, x, w, pdst, poff, soff, depth) \
	tilepbits(psrc, x, w, pdst, poff, soff, depth)

#endif /* mc68020 */
#endif /* __GNUC__ */

#define slo_putbits(src, x, w, pdst) \
{ \
    register int n = (x)+(w)-32; \
    \
    if (n <= 0) \
    { \
	register int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	*(pdst) = (*(pdst) & ~tmpmask) | \
		(SCRRIGHT((unsigned) src, x) & tmpmask); \
    } \
    else \
    { \
	*(pdst) = (*(pdst) & cfbendtab[x]) | (SCRRIGHT((unsigned) (src), x)); \
	(pdst)[1] = ((pdst)[1] & cfbstarttab[n]) | \
		(SCRLEFT((unsigned) src, 32-(x)) & cfbendtab[n]); \
    } \
}

#define slo_opaqpbits(src, x, w, pdst, poff, depth) \
{ \
    int n = (x)+(w)-32; \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	t1 = SCRRIGHT((unsigned) src, x); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		t2 = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(t2 & tmpmask); \
	    } \
	    tdst += poff; \
	} \
    } \
    else \
    { \
	register int _tmp; \
	t1 = SCRRIGHT((unsigned) src, x); \
	t2 = SCRLEFT((unsigned) src, 32-(x)); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
		*(tdst) = (*(tdst) & cfbendtab[x]) | \
			(_tmp & cfbstarttab[x]); \
		_tmp = (t2 & cfbfgmk[pcnt]) | (~t2 & cfbbgmk[pcnt]); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(_tmp & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	} \
    } \
}

#define slo_tilepbits(psrc, x, w, pdst, poff, soff, depth) \
{ \
    register int n = (x)+(w)-32; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = SCRRIGHT((unsigned) tsrc, x); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(_tmp & tmpmask); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = SCRRIGHT((unsigned) tsrc, x); \
		*(tdst) = (*(tdst) & cfbendtab[x]) | \
			(_tmp & cfbstarttab[x]); \
		_tmp = SCRLEFT((unsigned) tsrc, 32-(x)); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(_tmp & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#define _slo_putbits(src, x, w, pdst) \
{ \
    register int n = (x)+(w)-32; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	*(pdst) = SCRRIGHT((unsigned) src, x) & tmpmask; \
    } \
    else \
    { \
	*(pdst) = cfbstarttab[x] & SCRRIGHT((unsigned) (src), x); \
	(pdst)[1] = SCRLEFT((unsigned) src, 32-(x)) & cfbendtab[n]; \
    } \
}

#define _slo_tilepbits(psrc, x, w, pdst, poff, soff, depth, rop) \
{ \
    register int n = (x)+(w)-32; \
    register int pcnt; \
    register int *tdst = pdst; \
    register int *tsrc = psrc; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	sx_set_op(rop, tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		*(pdst) = SCRRIGHT((unsigned) *(tsrc), x); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		sx_set_op(rop, cfbstarttab[x]); \
		*(pdst) = SCRRIGHT((unsigned) *(tsrc), x); \
		sx_set_op(rop, cfbendtab[n]); \
		(pdst)[1] = SCRLEFT((unsigned) *(tsrc), 32-(x)); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#define _putbits(src, x, w, pdst) _slo_putbits(src, x, w, pdst)

#define _tilepbits(psrc, x, w, pdst, poff, soff, depth, rop) \
    _slo_tilepbits(psrc, x, w, pdst, poff, soff, depth, rop)

#if !defined(FASTPUTBITS)
#define putbits(src, x, w, pdst, poff, depth) \
    slo_putbits(src, x, w, pdst, poff, depth)

#define opaqpbits(src, x, w, pdst, poff, depth) \
    slo_opaqpbits(src, x, w, pdst, poff, depth)

#define tilepbits(psrc, x, w, pdst, poff, soff, depth) \
    slo_tilepbits(psrc, x, w, pdst, poff, soff, depth)

#define _PUTBITS(src, x, w, pdst) _slo_putbits(src, x, w, pdst)

#define _TILEPBITS(psrc, x, w, pdst, poff, soff, depth) \
    _slo_tilepbits(psrc, x, w, pdst, poff, soff, depth, GXcopy)
#endif

#ifndef getbits
#define getbits(psrc, x, w, dst) \
{ \
    dst = SCRLEFT((unsigned) *(psrc), (x)); \
    if ( ((x) + (w)) > 32) \
	dst |= (SCRRIGHT((unsigned) *((psrc)+1), 32-(x))); \
}
#endif

#define stippbits(src, x, w, pdst, poff, depth) \
{ \
    int n = (x)+(w)-32; \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	unsigned int mk1; \
	maskpartialbits((x), (w), tmpmask); \
	t1 = SCRRIGHT((unsigned) src, x); \
	mk1 = ~(tmpmask & t1); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		*(tdst) = (*(tdst) & mk1) | ((t1 & cfbfgmk[pcnt]) & tmpmask); \
	    } \
	    tdst += poff; \
	} \
    } \
    else \
    { \
	unsigned int mk1, mk2; \
	t1 = SCRRIGHT((unsigned) src, x); \
	t2 = SCRLEFT((unsigned) src, 32-(x)); \
	mk1 = cfbendtab[x] | ~t1; \
	mk2 = cfbstarttab[n] | ~t2; \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		*(tdst) = (*(tdst) & mk1) | \
			((t1 & cfbfgmk[pcnt]) & cfbstarttab[x]); \
		(tdst)[1] = ((tdst)[1] & mk2) | \
			((t2 & cfbfgmk[pcnt]) & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	} \
    } \
}

#define slo_opaqpbitsrop(src, x, w, pdst, poff, depth, rop) \
{ \
    int n = (x)+(w)-32; \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	t1 = SCRRIGHT((unsigned) src, x); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		t2 = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(rop(t2, *(tdst)) & tmpmask); \
	    } \
	    tdst += poff; \
	} \
    } \
    else \
    { \
	register unsigned int _tmp; \
	t1 = SCRRIGHT((unsigned) src, x); \
	t2 = SCRLEFT((unsigned) src, 32-(x)); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
		*(tdst) = (*(tdst) & cfbendtab[x]) | \
			(rop(_tmp, *(tdst)) & cfbstarttab[x]); \
		_tmp = (t2 & cfbfgmk[pcnt]) | (~t2 & cfbbgmk[pcnt]); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(rop(_tmp, (tdst)[1]) & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	} \
    } \
}

#define slo_tilepbitsrop(psrc, x, w, pdst, poff, soff, depth, rop) \
{ \
    register int n = (x)+(w)-32; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((x), (w), tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = SCRRIGHT((unsigned) tsrc, x); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(rop(_tmp, *(tdst)) & tmpmask); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = SCRRIGHT((unsigned) tsrc, x); \
		*(tdst) = (*(tdst) & cfbendtab[x]) | \
			(rop(_tmp, *(tdst)) & cfbstarttab[x]); \
		_tmp = SCRLEFT((unsigned) tsrc, 32-(x)); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(rop(_tmp, (tdst)[1]) & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#if defined(FASTPUTBITS)
#define opaqpbitsrop(src, x, w, pdst, poff, depth, rop) \
{ \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    t1 = SCRRIGHT((unsigned) (src),32-(w)); \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    t2 = (t1 & cfbfgmk[pcnt]) | (~t1 & cfbbgmk[pcnt]); \
	    t2 = rop(t2, *(tdst)); \
	    FASTPUTBITS(t2, x, w, tdst); \
	} \
	tdst += poff; \
    } \
}

#define tilepbitsrop(psrc, x, w, pdst, poff, soff, depth, rop) \
{ \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = rop(SCRRIGHT((unsigned) *(tsrc),32-(w)), *(tdst)); \
	    FASTPUTBITS(_tmp, x, w, tdst); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}
#endif

#if !defined(FASTPUTBITS)
#define opaqpbitsrop(src, x, w, pdst, poff, depth, rop) \
    slo_opaqpbitsrop(src, x, w, pdst, poff, depth, rop)

#define tilepbitsrop(psrc, x, w, pdst, poff, soff, depth, rop) \
    slo_tilepbitsrop(psrc, x, w, pdst, poff, soff, depth, rop)
#endif

#define stippbitsrop(src, x, w, pdst, poff, depth, rop) \
{ \
    int n = (x)+(w)-32; \
    register unsigned int t1, t2; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	unsigned int mk1, mk2; \
	maskpartialbits((x), (w), tmpmask); \
	t1 = SCRRIGHT((unsigned) src, x); \
	mk1 = ~(tmpmask & t1); \
	mk2 = tmpmask & t1; \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		t2 = rop((t1 & cfbfgmk[pcnt]), *(tdst)); \
		*(tdst) = (*(tdst) & mk1) | (t2 & mk2); \
	    } \
	    tdst += poff; \
	} \
    } \
    else \
    { \
	register unsigned int _tmp; \
	unsigned int mk1, mk2, mk3, mk4; \
	t1 = SCRRIGHT((unsigned) src, x); \
	t2 = SCRLEFT((unsigned) src, 32-(x)); \
	mk1 = cfbendtab[x] | ~t1; \
	mk2 = cfbstarttab[x] & t1; \
	mk3 = cfbstarttab[n] | ~t2; \
	mk4 = cfbendtab[n] & t2; \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		_tmp = rop((t1 & cfbfgmk[pcnt]), *(tdst)); \
		*(tdst) = (*(tdst) & mk1) | (_tmp & mk2); \
		_tmp = rop((t2 & cfbfgmk[pcnt]), (tdst)[1]); \
		(tdst)[1] = ((tdst)[1] & mk3) | (_tmp & mk4); \
	    } \
	    tdst += poff; \
	} \
    } \
}

#if GETLEFTBITS_ALIGNMENT == 1
#define getleftbits(psrc, w, dst)	dst = *((unsigned int *) psrc)
#endif /* GETLEFTBITS_ALIGNMENT == 1 */

#if GETLEFTBITS_ALIGNMENT == 2
#define getleftbits(psrc, w, dst) \
    { \
	if ( ((int)(psrc)) & 0x01 ) \
		getbits( ((unsigned int *)(((char *)(psrc))-1)), 8, (w), (dst) ); \
	else \
		getbits(psrc, 0, w, dst);
    }
#endif /* GETLEFTBITS_ALIGNMENT == 2 */

#if GETLEFTBITS_ALIGNMENT == 4
#define getleftbits(psrc, w, dst) \
    { \
	int off, off_b; \
	off_b = (off = ( ((int)(psrc)) & 0x03)) << 3; \
	getbits( \
		(unsigned int *)( ((char *)(psrc)) - off), \
		(off_b), (w), (dst) \
	       ); \
    }
#endif /* GETLEFTBITS_ALIGNMENT == 4 */


#define getshiftedleftbits(psrc, offset, w, dst) \
	getleftbits((psrc), (w), (dst)); \
	dst = SCRLEFT((dst), (offset));

/* FASTGETBITS and FASTPUTBITS are not necessarily correct implementations of
 * getbits and putbits, but they work if used together.
 *
 * On a MSBFirst machine, a cpu bitfield extract instruction (like bfextu)
 * could normally assign its result to a long word register in the screen
 * right position.  This saves canceling register shifts by not fighting the
 * natural cpu byte order.
 *
 */

#define _slo_getandputbits(psrc, srcbit, dstbit, width, pdst, drawbit) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    _slo_putbits(drawbit(_tmpbits), dstbit, width, pdst); \
}

#define _slo_tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth, rop) \
{ \
    register int n = (dstbit)+(w)-32; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = pdst; \
    register int *tsrc = psrc; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((dstbit), (w), tmpmask); \
	sx_set_op(rop, tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmp); \
		*(pdst) = SCRRIGHT((unsigned) _tmp, dstbit); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmp); \
		sx_set_op(rop, cfbstarttab[dstbit]); \
		*(pdst) = SCRRIGHT((unsigned) _tmp, dstbit); \
		sx_set_op(rop, cfbendtab[n]); \
		(pdst)[1] = SCRLEFT((unsigned) _tmp, 32-(dstbit)); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#define _slo_getandputbits0(psrc, sbindex, width, pdst, drawbit) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT (*(((unsigned *)(psrc)) + 1), _flag); \
    \
    *(pdst) = drawbit(_src) & cfbendtab[(width)]; \
}

#define _slo_tilegandpbits0(psrc, sbindex, width, pdst, poff, soff, depth, rop) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register int pcnt; \
    register int *tdst = pdst; \
    register int *tsrc = psrc; \
    \
    sx_set_op(rop, cfbendtab[(width)]); \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _src = SCRLEFT (*(tsrc), (sbindex)); \
	    if ((width) > _flag) \
		_src |=  SCRRIGHT (*(((unsigned *)(tsrc)) + 1), _flag); \
	    \
	    *(pdst) = _src; \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define _getandputbits(psrc, srcbit, dstbit, width, pdst, drawbit) \
    _slo_getandputbits(psrc, srcbit, dstbit, width, pdst, drawbit)

#define _tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth, rop) \
    _slo_tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth, rop)

#define _getandputbits0(psrc, sbindex, width, pdst, drawbit) \
    _slo_getandputbits0(psrc, sbindex, width, pdst, drawbit)

#define _tilegandpbits0(psrc, sbindex, width, pdst, poff, soff, depth, rop) \
    _slo_tilegandpbits0(psrc, sbindex, width, pdst, poff, soff, depth, rop)

#define stipgandpbits(psrc, srcbit, dstbit, width, pdst, poff, depth) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    stippbits(_tmpbits, dstbit, width, pdst, poff, depth); \
}

#define stipgandpbitsrop(psrc, srcbit, dstbit, width, pdst, poff, depth, rop) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    stippbitsrop(_tmpbits, dstbit, width, pdst, poff, depth, rop); \
}

#if defined(FASTGETBITS) && defined(FASTPUTBITS)
#define getandputbits(psrc, srcbit, dstbit, width, pdst) \
{ \
    register unsigned int _tmpbits; \
    FASTGETBITS(psrc, srcbit, width, _tmpbits); \
    FASTPUTBITS(_tmpbits, dstbit, width, pdst); \
}

#define opaqgandpbits(psrc, srcbit, dstbit, width, pdst, poff, depth) \
{ \
    register unsigned int _tmpbits; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    FASTGETBITS(psrc, srcbit, width, _tmpbits); \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = (_tmpbits & cfbfgmk[pcnt]) | \
		    (~_tmpbits & cfbbgmk[pcnt]); \
	    FASTPUTBITS(_tmp, dstbit, width, tdst); \
	} \
	tdst += poff; \
    } \
}

#define opaqgandpbitsrop(psrc, srcbit, dstbit, width, pdst, poff, depth, rop) \
{ \
    register unsigned int _tmpbits; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    FASTGETBITS(psrc, srcbit, width, _tmpbits); \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = (_tmpbits & cfbfgmk[pcnt]) | \
		    (~_tmpbits & cfbbgmk[pcnt]); \
	    _tmp = rop(_tmp, *(tdst)); \
	    FASTPUTBITS(_tmp, dstbit, width, tdst); \
	} \
	tdst += poff; \
    } \
}

#define tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth) \
{ \
    register unsigned int _tmpbits; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    FASTGETBITS(tsrc, srcbit, width, _tmpbits); \
	    FASTPUTBITS(_tmpbits, dstbit, width, tdst); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define tilegandpbitsrop(psrc, srcbit, dstbit, width, pdst, poff, soff, depth, rop) \
{ \
    register unsigned int _tmpbits; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    FASTGETBITS(tsrc, srcbit, width, _tmpbits); \
	    _tmpbits = rop(_tmpbits, *(tdst)); \
	    FASTPUTBITS(_tmpbits, dstbit, width, tdst); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define _GETANDPUTBITS(psrc, srcbit, dstbit, width, pdst, drawbit) \
{ \
    register unsigned int _tmpbits; \
    FASTGETBITS(psrc, srcbit, width, _tmpbits); \
    FASTPUTBITS(drawbit(_tmpbits), dstbit, width, pdst); \
}

#define _TILEGANDPBITS(psrc, srcbit, dstbit, width, pdst, poff, soff, depth) \
	tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth)

#define getandputbits0(psrc, srcbit, width, pdst) \
    getandputbits(psrc, srcbit, 0, width, pdst)

#define stipgandpbits0(psrc, sbindex, width, pdst, poff, depth) \
{ \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    unsigned int mk1; \
    \
    getbits(psrc, sbindex, width, _src); \
    \
    mk1 = cfbstarttab[(width)] | ~_src; \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = _src & cfbfgmk[pcnt]; \
	    *(tdst) = (*(tdst) & mk1) | (_tmp & cfbendtab[(width)]); \
	} \
	tdst += poff; \
    } \
}

#define stipgandpbitsrop0(psrc, sbindex, width, pdst, poff, depth, rop) \
{ \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    unsigned int mk1, mk2; \
    \
    getbits(psrc, sbindex, width, _src); \
    \
    mk1 = cfbstarttab[(width)] | ~_src; \
    mk2 = cfbendtab[(width)] & _src; \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = rop((_src & cfbfgmk[pcnt]), *(tdst)); \
	    *(tdst) = (*(tdst) & mk1) | (_tmp & mk2); \
	} \
	tdst += poff; \
    } \
}

#define opaqgandpbits0(psrc, srcbit, width, pdst, poff, depth) \
    opaqgandpbits(psrc, srcbit, 0, width, pdst, poff, depth)

#define opaqgandpbitsrop0(psrc, srcbit, width, pdst, poff, depth, rop) \
    opaqgandpbitsrop(psrc, srcbit, 0, width, pdst, poff, depth, rop)

#define tilegandpbits0(psrc, srcbit, width, pdst, poff, soff, depth) \
    tilegandpbits(psrc, srcbit, 0, width, pdst, poff, soff, depth)

#define tilegandpbitsrop0(psrc, srcbit, width, pdst, poff, soff, depth, rop) \
    tilegandpbitsrop(psrc, srcbit, 0, width, pdst, poff, soff, depth, rop)

#define _GETANDPUTBITS0(psrc, srcbit, width, pdst, drawbit) \
    _GETANDPUTBITS(psrc, srcbit, 0, width, pdst, drawbit)

#define _TILEGANDPBITS0(psrc, srcbit, width, pdst, poff, soff, depth) \
    _TILEGANDPBITS(psrc, srcbit, 0, width, pdst, poff, soff, depth)
#else /* Slow poke */

/* pairs of getbits/putbits happen frequently. Some of the code can
 * be shared or avoided in a few specific instances.  It gets us a
 * small advantage, so we do it.  The getandput...0 macros are the only ones
 * which speed things here.  The others are here for compatibility w/the above
 * FAST ones
 */

#define getandputbits(psrc, srcbit, dstbit, width, pdst) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    putbits(_tmpbits, dstbit, width, pdst); \
}

#define opaqgandpbits(psrc, srcbit, dstbit, width, pdst, poff, depth) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    opaqpbits(_tmpbits, dstbit, width, pdst, poff, depth); \
}

#define opaqgandpbitsrop(psrc, srcbit, dstbit, width, pdst, poff, depth, rop) \
{ \
    register unsigned int _tmpbits; \
    getbits(psrc, srcbit, width, _tmpbits); \
    opaqpbitsrop(_tmpbits, dstbit, width, pdst, poff, depth, rop); \
}

#define tilegandpbits(psrc, srcbit, dstbit, width, pdst, poff, soff, depth) \
{ \
    register int n = (dstbit)+(w)-32; \
    register unsigned int _tmpbits, _tmp; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((dstbit), (w), tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmpbits); \
		_tmp = SCRRIGHT((unsigned) _tmpbits, dstbit); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(_tmp & tmpmask); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmpbits); \
		_tmp = SCRRIGHT((unsigned) _tmpbits, dstbit); \
		*(tdst) = (*(tdst) & cfbendtab[dstbit]) | \
			(_tmp & cfbstarttab[dstbit]); \
		_tmp = SCRLEFT((unsigned) _tmpbits, 32-(dstbit)); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(_tmp & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#define tilegandpbitsrop(psrc, srcbit, dstbit, width, pdst, poff, soff, depth, rop) \
{ \
    register int n = (dstbit)+(w)-32; \
    register unsigned int _tmpbits, _tmp; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    if (n <= 0) \
    { \
	register unsigned int tmpmask; \
	maskpartialbits((dstbit), (w), tmpmask); \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmpbits); \
		_tmp = SCRRIGHT((unsigned) _tmpbits, dstbit); \
		*(tdst) = (*(tdst) & ~tmpmask) | \
			(rop(_tmp, *(tdst)) & tmpmask); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
    else \
    { \
	for (pcnt = 0; pcnt < depth; pcnt++) \
	{ \
	    if (cfbplmk[pcnt]) \
	    { \
		getbits(tsrc, srcbit, w, _tmpbits); \
		_tmp = SCRRIGHT((unsigned) _tmpbits, dstbit); \
		*(tdst) = (*(tdst) & cfbendtab[dstbit]) | \
			(rop(_tmp, *(tdst)) & cfbstarttab[dstbit]); \
		_tmp = SCRLEFT((unsigned) _tmpbits, 32-(dstbit)); \
		(tdst)[1] = ((tdst)[1] & cfbstarttab[n]) | \
			(rop(_tmp, (tdst)[1]) & cfbendtab[n]); \
	    } \
	    tdst += poff; \
	    tsrc += soff; \
	} \
    } \
}

#define _GETANDPUTBITS(psrc, srcbit, dstbit, width, pdst, drawbit) \
    _slo_getandputbits(psrc, srcbit, dstbit, width, pdst, drawbit)

#define _TILEGANDPBITS(psrc, srcbit, dstbit, width, pdst, poff, soff, depth) \
    _slo_tilegandpbits(psrc, srcbit, dstbit, width, pdst, \
					poff, soff, depth, GXcopy)

#define getandputbits0(psrc, sbindex, width, pdst) \
{ \
    register int          _flag = 32 - (sbindex); \
    register unsigned int _src; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT ((unsigned) *((psrc) + 1), _flag); \
    \
    *(pdst) = (*(pdst) & cfbstarttab[(width)]) | (_src & cfbendtab[(width)]); \
}

#define stipgandpbits0(psrc, sbindex, width, pdst, poff, depth) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    unsigned int mk1; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT ((unsigned) *((psrc) + 1), _flag); \
    \
    mk1 = cfbstarttab[(width)] | ~_src; \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = _src & cfbfgmk[pcnt]; \
	    *(tdst) = (*(tdst) & mk1) | (_tmp & cfbendtab[(width)]); \
	} \
	tdst += poff; \
    } \
}

#define stipgandpbitsrop0(psrc, sbindex, width, pdst, poff, depth, rop) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = (int *)pdst; \
    unsigned int mk1, mk2; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT ((unsigned) *((psrc) + 1), _flag); \
    \
    mk1 = cfbstarttab[(width)] | ~_src; \
    mk2 = cfbendtab[(width)] & _src; \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = rop((_src & cfbfgmk[pcnt]), *(tdst)); \
	    *(tdst) = (*(tdst) & mk1) | (_tmp & mk2); \
	} \
	tdst += poff; \
    } \
}

#define opaqgandpbits0(psrc, sbindex, width, pdst, poff, depth) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT ((unsigned) *((psrc) + 1), _flag); \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = (_src & cfbfgmk[pcnt]) | (~_src & cfbbgmk[pcnt]); \
	    *(tdst) = (*(tdst) & cfbstarttab[(width)]) | \
		    (_tmp & cfbendtab[(width)]); \
	} \
	tdst += poff; \
    } \
}

#define opaqgandpbitsrop0(psrc, sbindex, width, pdst, poff, depth, rop) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register unsigned int _tmp; \
    register int pcnt; \
    register int *tdst = pdst; \
    \
    _src = SCRLEFT (*(psrc), (sbindex)); \
    if ((width) > _flag) \
	_src |=  SCRRIGHT ((unsigned) *((psrc) + 1), _flag); \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _tmp = (_src & cfbfgmk[pcnt]) | (~_src & cfbbgmk[pcnt]); \
	    *(tdst) = (*(tdst) & cfbstarttab[(width)]) | \
		    (rop(_tmp, *(tdst)) & cfbendtab[(width)]); \
	} \
	tdst += poff; \
    } \
}

#define tilegandpbits0(psrc, sbindex, width, pdst, poff, soff, depth) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _src = SCRLEFT (*(tsrc), (sbindex)); \
	    if ((width) > _flag) \
		_src |=  SCRRIGHT ((unsigned) *((tsrc) + 1), _flag); \
	    *(tdst) = (*(tdst) & cfbstarttab[(width)]) | \
		    (_src & cfbendtab[(width)]); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define tilegandpbitsrop0(psrc, sbindex, width, pdst, poff, soff, depth, rop) \
{ \
    register int _flag = 32 - (sbindex); \
    register unsigned int _src; \
    register int pcnt; \
    register int *tsrc = psrc; \
    register int *tdst = pdst; \
    \
    for (pcnt = 0; pcnt < depth; pcnt++) \
    { \
	if (cfbplmk[pcnt]) \
	{ \
	    _src = SCRLEFT (*(tsrc), (sbindex)); \
	    if ((width) > _flag) \
		_src |=  SCRRIGHT ((unsigned) *((tsrc) + 1), _flag); \
	    *(tdst) = (*(tdst) & cfbstarttab[(width)]) | \
		    (rop(_src, *(tdst)) & cfbendtab[(width)]); \
	} \
	tdst += poff; \
	tsrc += soff; \
    } \
}

#define _GETANDPUTBITS0(psrc, sbindex, width, pdst, drawbit) \
    _slo_getandputbits0(psrc, sbindex, width, pdst, drawbit)

#define _TILEGANDPBITS0(psrc, sbindex, width, pdst, poff, soff, depth) \
    _slo_tilegandpbits0(psrc, sbindex, width, pdst, poff, soff, depth, GXcopy)
#endif  /* FASTGETBITS && FASTPUTBITS */

/* common plane check */
#define getOmronFbInfo( pDrawable ) \
  (OmronFbInfoPtr)(pDrawable->pScreen->devPrivates[omronScreenIndex].ptr)

#define	isCommonPlane( ptr, pFbInfo )	((char *)(ptr) == (pFbInfo->cplane))
#define	getPlaneAddres(pFbInfo)		((pFbInfo->plane))

/* Byte size */
#define	getFbPlaneByteSize()	0x40000
/* Word size */
#define	getFbPlaneWordSize()	0x20000
/* Long size */
#define	getFbPlaneLongSize()	0x10000
