/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include "X.h"
#include "gcstruct.h"
#include "windowstr.h"
#include "pixmapstr.h"
#include "regionstr.h"
#include "scrnintstr.h"
#include "cfb.h"
#include "cfbmskbits.h"

#define POLYPNT(ROP) \
    for (plane = 0; plane < depth; plane++) \
    { \
	if (cfbplmk[plane]) \
	{ \
	    *addr = ( (ROP(cfbfgmk[plane], *addr) & cfbmask[x & PIM]) | \
		    (*addr & cfbrmask[x & PIM]) ); \
	} \
	addr += pljmp; \
    }

void
cfbPolyPoint(pDrawable, pGC, mode, npt, pptInit)
    DrawablePtr pDrawable;
    GCPtr pGC;
    int mode;
    int npt;
    xPoint *pptInit;
{
    register int *addr;
    register xPoint *ppt;
    RegionPtr cclip;
    int nbox;
    register int x, y;
    register int i;
    int *addrl;
    register int nlwidth;
    register BoxPtr pbox;
    int rop;
    unsigned long pixel;
    unsigned long planemask;
    unsigned long mask;
    register int x1, x2, y1, y2;
    register int xoff, yoff;
    int pljmp;
    int plane, depth;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    rop = pGC->alu;
    planemask = pGC->planemask;
    pixel = pGC->fgPixel;
    depth = pDrawable->depth;

    if ((mode == CoordModePrevious) && (npt > 1))
    {
	for (ppt = pptInit + 1, i = npt - 1; --i >= 0; ppt++)
	{
	    ppt->x += (ppt-1)->x;
	    ppt->y += (ppt-1)->y;
	}
    }
    cclip = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip;
    xoff = pDrawable->x;
    yoff = pDrawable->y;

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	addrl = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;

	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	for (nbox = REGION_NUM_RECTS(cclip), pbox = REGION_RECTS(cclip);
	    --nbox >= 0;
	    pbox++)
	{
	    x1 = pbox->x1;
	    y1 = pbox->y1;
	    x2 = pbox->x2;
	    y2 = pbox->y2;
	    for (ppt = pptInit, i = npt; --i >= 0; ppt++)
	    {
		x = ppt->x + xoff;
		y = ppt->y + yoff;
		if ((x >= x1) && (x < x2) &&
		    (y >= y1) && (y < y2))
		{
		    addr = addrl + (y * nlwidth) + (x >> PWSH);
		    *addr = cfbmask[x & PIM];
		}
	    }
	}
    }
    else
    {
	addrl = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	pljmp = nlwidth * pDrawable->height;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	}

	for (nbox = REGION_NUM_RECTS(cclip), pbox = REGION_RECTS(cclip);
	    --nbox >= 0;
	    pbox++)
	{
	    x1 = pbox->x1;
	    y1 = pbox->y1;
	    x2 = pbox->x2;
	    y2 = pbox->y2;
	    for (ppt = pptInit, i = npt; --i >= 0; ppt++)
	    {
		x = ppt->x + xoff;
		y = ppt->y + yoff;
		if ((x >= x1) && (x < x2) &&
		    (y >= y1) && (y < y2))
		{
		    addr = addrl + (y * nlwidth) + (x >> PWSH);
		    switch(rop)
		    {
			case GXcopy:
			    POLYPNT(fnCOPY);
			    break;
			case GXxor:
			    POLYPNT(fnXOR);
			    break;
			case GXand:
			    POLYPNT(fnAND);
			    break;
			case GXor:
			    POLYPNT(fnOR);
			    break;
			case GXset:
			    POLYPNT(fnSET);
			    break;
			case GXclear:
			    POLYPNT(fnCLEAR);
			    break;
			case GXandReverse:
			    POLYPNT(fnANDREVERSE);
			    break;
			case GXandInverted:
			    POLYPNT(fnANDINVERTED);
			    break;
			case GXnor:
			    POLYPNT(fnNOR);
			    break;
			case GXequiv:
			    POLYPNT(fnEQUIV);
			    break;
			case GXinvert:
			    POLYPNT(fnINVERT);
			    break;
			case GXorReverse:
			    POLYPNT(fnORREVERSE);
			    break;
			case GXcopyInverted:
			    POLYPNT(fnCOPYINVERTED);
			    break;
			case GXorInverted:
			    POLYPNT(fnORINVERTED);
			    break;
			case GXnand:
			    POLYPNT(fnNAND);
			    break;
			default:
			    break;
		    }
		}
	    }
	}
    }
}
