/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include	"X.h"
#include	"Xmd.h"
#include	"Xproto.h"
#include	"fontstruct.h"
#include	"dixfontstr.h"
#include	"gcstruct.h"
#include	"windowstr.h"
#include	"scrnintstr.h"
#include	"pixmapstr.h"
#include	"regionstr.h"
#include	"cfb.h"
#include	"cfbmskbits.h"
#include	"cfbfastblt.h"

extern void mfbPushPixels();

#define PUSHPIXCOPY \
    if (x + width < PPW) \
    { \
	while (dy--) \
	{ \
	    src = psrcLine; \
	    dst = pdstLine; \
	    stippbits(*src, x, width, dst, dstpljmp, depth); \
	    pdstLine += dstWidth; \
	    psrcLine += srcWidth; \
	} \
    } \
    else \
    { \
	maskbits(xOrg, width, startmask, endmask, nlMiddle); \
	if (startmask) \
	    nstart = PPW - x; \
	else \
	    nstart = 0; \
	if (endmask) \
	    nend = (xOrg + width) & PIM; \
	else \
	    nend = 0; \
	srcStartOver = nstart > PLST; \
	if (startmask && endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		stippbits(*src, x, nstart, dst, dstpljmp, depth); \
		dst++; \
		if(srcStartOver) \
		    src++; \
		while(nl--) \
		{ \
		    stipgandpbits0(src, nstart, PPW, dst, dstpljmp, depth); \
		    dst++; \
		    src++; \
		} \
		stipgandpbits0(src, nstart, nend, dst, dstpljmp, depth); \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else if (startmask && !endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		stippbits(*src, x, nstart, dst, dstpljmp, depth); \
		dst++; \
		if(srcStartOver) \
		    src++; \
		while(nl--) \
		{ \
		    stipgandpbits0(src, nstart, PPW, dst, dstpljmp, depth); \
		    dst++; \
		    src++; \
		} \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else if (!startmask && endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		while(nl--) \
		{ \
		    stipgandpbits0(src, nstart, PPW, dst, dstpljmp, depth); \
		    dst++; \
		    src++; \
		} \
		stipgandpbits0(src, nstart, nend, dst, dstpljmp, depth); \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		while(nl--) \
		{ \
		    stipgandpbits0(src, nstart, PPW, dst, dstpljmp, depth); \
		    dst++; \
		    src++; \
		} \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
    }

#define PUSHPIX(ROP) \
    if (x + width < PPW) \
    { \
	while (dy--) \
	{ \
	    src = psrcLine; \
	    dst = pdstLine; \
	    stippbitsrop(*src, x, width, dst, dstpljmp, depth, ROP); \
	    pdstLine += dstWidth; \
	    psrcLine += srcWidth; \
	} \
    } \
    else \
    { \
	maskbits(xOrg, width, startmask, endmask, nlMiddle); \
	if (startmask) \
	    nstart = PPW - x; \
	else \
	    nstart = 0; \
	if (endmask) \
	    nend = (xOrg + width) & PIM; \
	else \
	    nend = 0; \
	srcStartOver = nstart > PLST; \
	if (startmask && endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		stippbitsrop(*src, x, nstart, dst, dstpljmp, depth, ROP); \
		dst++; \
		if(srcStartOver) \
		    src++; \
		while(nl--) \
		{ \
		    stipgandpbitsrop0(src, nstart, PPW, dst, dstpljmp, depth, ROP); \
		    dst++; \
		    src++; \
		} \
		stipgandpbitsrop0(src, nstart, nend, dst, dstpljmp, depth, ROP); \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else if (startmask && !endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		stippbitsrop(*src, x, nstart, dst, dstpljmp, depth, ROP); \
		dst++; \
		if(srcStartOver) \
		    src++; \
		while(nl--) \
		{ \
		    stipgandpbitsrop0(src, nstart, PPW, dst, dstpljmp, depth, ROP); \
		    dst++; \
		    src++; \
		} \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else if (!startmask && endmask) \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		while(nl--) \
		{ \
		    stipgandpbitsrop0(src, nstart, PPW, dst, dstpljmp, depth, ROP); \
		    dst++; \
		    src++; \
		} \
		stipgandpbitsrop0(src, nstart, nend, dst, dstpljmp, depth, ROP); \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
	else \
	{ \
	    while (dy--) \
	    { \
		nl = nlMiddle; \
		src = psrcLine; \
		dst = pdstLine; \
		while(nl--) \
		{ \
		    stipgandpbitsrop0(src, nstart, PPW, dst, dstpljmp, depth, ROP); \
		    dst++; \
		    src++; \
		} \
		pdstLine += dstWidth; \
		psrcLine += srcWidth; \
	    } \
	} \
    }

void
cfbPushPixels (pGC, pBitmap, pDrawable, dx, dy, xOrg, yOrg)
    GCPtr	 pGC;
    PixmapPtr	 pBitmap;
    DrawablePtr	 pDrawable;
    int		 dx;
    register int dy;
    int		 xOrg, yOrg;
{
    register unsigned int    *src, *dst;
    unsigned int    *pdstLine, *psrcLine;
    unsigned int    *pdstBase;
    int		    srcWidth;
    int		    dstWidth;
    register unsigned int   startmask;
    register unsigned int   endmask;
    unsigned long   pixel;
    unsigned long   planemask;
    int		    rop;
    int		    nlMiddle;
    int		    width, srcStartOver, nstart, nend;
    int		    depth;
    register int    x;
    register int    nl;
    register unsigned int tmp1, tmp2;
    BoxRec	    bbox;
    OmronFbInfoPtr  fbInfo;
    int drawFbFlag;

    if (!(pGC->planemask) || pGC->alu == GXnoop)
	return;

    bbox.x1 = xOrg;
    bbox.y1 = yOrg;
    bbox.x2 = bbox.x1 + dx;
    bbox.y2 = bbox.y1 + dy;

    switch ((*pGC->pScreen->RectIn)(
                ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip, &bbox))
    {
      case rgnPART:
	mfbPushPixels(pGC, pBitmap, pDrawable, dx, dy, xOrg, yOrg);
      case rgnOUT:
	return;
    }

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pdstBase = (unsigned int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	dstWidth = (int)
		  (((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;
	drawFbFlag = TRUE;
    }
    else
    {
	pdstBase = (unsigned int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	dstWidth = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( pdstBase, fbInfo ))
	    drawFbFlag = TRUE;
	else
	    drawFbFlag = FALSE;
    }

    psrcLine = (unsigned int *) pBitmap->devPrivate.ptr;
    srcWidth = (int) pBitmap->devKind >> 2;

    depth = pDrawable->depth;
    pixel = pGC->fgPixel;
    planemask = pGC->planemask;

    rop = pGC->alu;
    x = xOrg & PIM;
    width = dx;

    if (drawFbFlag == TRUE)
    {
	pdstLine = pdstBase + (yOrg * dstWidth) + (xOrg >> PWSH);

	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	if ((x + width) < PPW)
	{
	    maskpartialbits(x, width, endmask);
	    src = psrcLine;
	    dst = pdstLine;
	    while (dy--)
	    {
		*dst = SCRRIGHT(*src, x) & endmask;

		dst += dstWidth;
		src += srcWidth;
	    }
	}
	else
	{
	    maskbits(xOrg, width, startmask, endmask, nlMiddle);

	    if (x == 0)
	    {
	    	while (dy--)
		{   
		    src = psrcLine;
		    dst = pdstLine;
		    if (startmask)
		    {
			*dst++ = (*src++) & startmask;
		    }
		    nl = nlMiddle;
#ifdef LARGE_INSTRUCTION_CACHE
#ifdef FAST_CONSTANT_OFFSET_MODE
	            src += nl & (UNROLL-1);
	            dst += nl & (UNROLL-1);
#define BodyOdd(n) dst[-n] = src[-n];
#define BodyEven(n) dst[-n] = src[-n];
#define LoopReset \
    dst += UNROLL; \
    src += UNROLL;
#else
#define BodyOdd(n)  *dst++ = *src++;
#define BodyEven(n) BodyOdd(n)
#define LoopReset   ;
#endif
	    	    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
	    	    DuffL(nl, label1, *dst++ = *src++;)
#endif
		    if (endmask)
		    {
			*dst = *src & endmask;
		    }
		    pdstLine += dstWidth;
		    psrcLine += srcWidth;
		} /* dy */
	    }
	    else 
	    {
		nstart = PPW - x;

	    	while (dy--)
	    	{
		    src = psrcLine;
		    dst = pdstLine;
		    tmp2 = tmp1 = 0;
		    if (startmask)
		    {
		    	tmp1 = *src++;
		    	tmp2 = SCRRIGHT(tmp1,x);
		    	*dst++ = tmp2 & startmask;
		    }
		    nl = nlMiddle;

#ifdef LARGE_INSTRUCTION_CACHE
		    tmp2 = tmp1;
#ifdef FAST_CONSTANT_OFFSET_MODE
		    src += nl & (UNROLL-1);
		    dst += nl & (UNROLL-1);
#define BodyOdd(n) \
    tmp1 = src[-n]; \
    dst[-n] = BitLeft(tmp2, nstart)|BitRight(tmp1, x);
#define BodyEven(n) \
    tmp2 = src[-n]; \
    dst[-n] = BitLeft(tmp1, nstart)|BitRight(tmp2, x);
#define LoopReset \
    dst += UNROLL; \
    src += UNROLL;
#else
#define BodyOdd(n) \
    tmp1 = *src++; \
    *dst++ = BitLeft(tmp2, nstart)|BitRight(tmp1, x);
#define BodyEven(n) \
    tmp2 = *src++; \
    *dst++ = BitLeft(tmp1, nstart)|BitRight(tmp2, x);
#define LoopReset   ;
#endif	/* !FAST_CONSTANT_OFFSET_MODE */
		    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
		    DuffL (nl,label2,
			tmp2 = BitLeft(tmp1, nstart);
			tmp1 = *src++;
			*dst++ = tmp2 | BitRight(tmp1, x);
	    	    )
#endif
		    if (endmask)
		    {
		    	tmp2 = SCRLEFT(tmp1, nstart);
		    	if (SCRLEFT(endmask, x))
		    	{
			    tmp1 = *src++;
			    tmp2 |= SCRRIGHT(tmp1, x);
		    	}
		    	*dst = tmp2 & endmask;
		    }
		    pdstLine += dstWidth;
		    psrcLine += srcWidth;
	    	} /* dy */
	    } 
    	}
    }
    else
    {
	int plane, dstpljmp;

	pdstLine = pdstBase + (yOrg * dstWidth) + (xOrg >> PWSH);
	dstpljmp = dstWidth * pDrawable->height;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	}

	switch(rop)
	{
	    case GXcopy:
		PUSHPIXCOPY;
		break;
	    case GXxor:
		PUSHPIX(fnXOR);
		break;
	    case GXand:
		PUSHPIX(fnAND);
		break;
	    case GXor:
		PUSHPIX(fnOR);
		break;
	    case GXset:
		PUSHPIX(fnSET);
		break;
	    case GXclear:
		PUSHPIX(fnCLEAR);
		break;
	    case GXandReverse:
		PUSHPIX(fnANDREVERSE);
		break;
	    case GXandInverted:
		PUSHPIX(fnANDINVERTED);
		break;
	    case GXnor:
		PUSHPIX(fnNOR);
		break;
	    case GXequiv:
		PUSHPIX(fnEQUIV);
		break;
	    case GXinvert:
		PUSHPIX(fnINVERT);
		break;
	    case GXorReverse:
		PUSHPIX(fnORREVERSE);
		break;
	    case GXcopyInverted:
		PUSHPIX(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		PUSHPIX(fnORINVERTED);
		break;
	    case GXnand:
		PUSHPIX(fnNAND);
		break;
	    default:
		break;
	}
    }
}
