/************************************************************
Copyright 1989 by The Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation, and that the name of MIT not be used in
advertising or publicity pertaining to distribution of the
software without specific prior written permission.
M.I.T. makes no representation about the suitability of
this software for any purpose. It is provided "as is"
without any express or implied warranty.

********************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include "X.h"
#include "Xprotostr.h"
#include "miscstruct.h"
#include "gcstruct.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "cfb.h"
#include "cfbmskbits.h"
#include "mizerarc.h"

extern void miPolyArc(), miZeroPolyArc();

#if (BITMAP_BIT_ORDER == MSBFirst)
#define LEFTMOST	((unsigned int) 0x80000000)
#else
#define LEFTMOST	((unsigned int) 1)
#endif

#define PIXELATE(base,off) \
{ \
    paddr = base + ((off)>>5); \
    srcbit = SCRRIGHT(LEFTMOST, (off) & 0x1f); \
    *paddr = srcbit; \
}

#define Pixelate(base,off, rop) \
{ \
    paddr = base + ((off)>>5); \
    srcbit = SCRRIGHT(LEFTMOST, (off) & 0x1f); \
    *paddr = (*paddr & ~srcbit) | (rop(cfbfgmk[plane], *paddr) & srcbit); \
}

#define DOPIX(bit,base,off) if (mask & bit) PIXELATE(base,off);

#define DoPix(bit,base,off, rop) if (mask & bit) Pixelate(base,off, rop);

#define ZEROARC(ROP) \
    if (!(arc->width & 1)) \
    { \
	for (plane = 0; plane < depth; plane++) \
	{ \
	    if (cfbplmk[plane]) \
	    { \
		DoPix(2, yorgl + poff[plane], info.xorgo, ROP); \
		DoPix(8, yorgol + poff[plane], info.xorgo, ROP); \
	    } \
	} \
    } \
    if (!info.end.x || !info.end.y) \
    { \
	mask = info.end.mask; \
	info.end = info.altend; \
    } \
    if (do360 && (arc->width == arc->height) && !(arc->width & 1)) \
    { \
	int xoffset = nlwidth; \
	int *yorghl = yorgl + (info.h * nlwidth); \
	int xorghp = info.xorg + info.h; \
	int xorghn = info.xorg - info.h; \
	while (1) \
	{ \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    Pixelate(yorgl + poff[plane] + yoffset, info.xorg + x, ROP); \
		    Pixelate(yorgl + poff[plane] + yoffset, info.xorg - x, ROP); \
		    Pixelate(yorgol + poff[plane]- yoffset, info.xorg - x, ROP); \
		    Pixelate(yorgol + poff[plane] - yoffset, info.xorg + x, ROP); \
		} \
	    } \
	    if (a < 0) \
		break; \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    Pixelate(yorghl + poff[plane] - xoffset, xorghp - y, ROP); \
		    Pixelate(yorghl + poff[plane] - xoffset, xorghn + y, ROP); \
		    Pixelate(yorghl + poff[plane] + xoffset, xorghn + y, ROP); \
		    Pixelate(yorghl + poff[plane] + xoffset, xorghp - y, ROP); \
		} \
	    } \
	    xoffset += nlwidth; \
	    MIARCCIRCLESTEP(yoffset += nlwidth;); \
	} \
	x = info.w; \
	yoffset = info.h * nlwidth; \
    } \
    else if (do360) \
    { \
	while (y < info.h || x < info.w) \
	{ \
	    MIARCOCTANTSHIFT(dyoffset = nlwidth;); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    Pixelate(yorgl + poff[plane] + yoffset, info.xorg + x, ROP); \
		    Pixelate(yorgl + poff[plane] + yoffset, info.xorgo - x, ROP); \
		    Pixelate(yorgol + poff[plane] - yoffset, info.xorgo - x, ROP); \
		    Pixelate(yorgol + poff[plane] - yoffset, info.xorg + x, ROP); \
		} \
	    } \
	    MIARCSTEP(yoffset += dyoffset;, yoffset += nlwidth;); \
	} \
    } \
    else \
    { \
	while (y < info.h || x < info.w) \
	{ \
	    MIARCOCTANTSHIFT(dyoffset = nlwidth;); \
	    if ((x == info.start.x) || (y == info.start.y)) \
	    { \
		mask = info.start.mask; \
		info.start = info.altstart; \
	    } \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    DoPix(1, yorgl + poff[plane] + yoffset, info.xorg + x, ROP); \
		    DoPix(2, yorgl + poff[plane] + yoffset, info.xorgo - x, ROP); \
		    DoPix(4, yorgol + poff[plane] - yoffset, info.xorgo - x, ROP); \
		    DoPix(8, yorgol + poff[plane] - yoffset, info.xorg + x, ROP); \
		} \
	    } \
	    if ((x == info.end.x) || (y == info.end.y)) \
	    { \
		mask = info.end.mask; \
		info.end = info.altend; \
	    } \
	    MIARCSTEP(yoffset += dyoffset;, yoffset += nlwidth;); \
	} \
    } \
    if ((x == info.start.x) || (y == info.start.y)) \
	mask = info.start.mask; \
    for (plane = 0; plane < depth; plane++) \
    { \
	if (cfbplmk[plane]) \
	{ \
	    DoPix(1, yorgl + poff[plane] + yoffset, info.xorg + x, ROP); \
	    DoPix(4, yorgol + poff[plane] - yoffset, info.xorgo - x, ROP); \
	    if (arc->height & 1) \
	    { \
		DoPix(2, yorgl + poff[plane] + yoffset, info.xorgo - x, ROP); \
		DoPix(8, yorgol + poff[plane] - yoffset, info.xorg + x, ROP); \
	    } \
	} \
    }

static void
cfbZeroArcSS(pDraw, pGC, arc)
    DrawablePtr pDraw;
    GCPtr pGC;
    xArc *arc;
{
    miZeroArcRec info;
    Bool do360;
    register int x, y, a, b, d, mask;
    register int k1, k3, dx, dy;
    int *addrl;
    int *yorgl, *yorgol;
    unsigned long pixel;
    int nlwidth, yoffset, dyoffset;
    int rop;
    unsigned long srcbit;
    unsigned long planemask;
    register int *paddr;
    int dstpljmp, depth;

    if (!(pGC->planemask) || pGC->alu == GXnoop)
	return;

    if (pDraw->type == DRAWABLE_WINDOW)
    {
	addrl = (int *)
		(((PixmapPtr)(pDraw->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
		(((PixmapPtr)(pDraw->pScreen->devPrivate))->devKind) >> 2;
    }
    else
    {
	addrl = (int *)(((PixmapPtr)pDraw)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDraw)->devKind) >> 2;
	dstpljmp = nlwidth * pDraw->height;
    }
    rop = pGC->alu;
    depth = pDraw->depth;
    planemask = pGC->planemask;
    pixel = pGC->fgPixel;
    do360 = miZeroArcSetup(arc, &info, TRUE);
    yorgl = addrl + ((info.yorg + pDraw->y) * nlwidth);
    yorgol = addrl + ((info.yorgo + pDraw->y) * nlwidth);
    info.xorg += pDraw->x;
    info.xorgo += pDraw->x;
    MIARCSETUP();
    yoffset = y ? nlwidth : 0;
    dyoffset = 0;
    mask = info.initialMask;
    if (pDraw->type == DRAWABLE_WINDOW)
    {
	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	if (!(arc->width & 1))
	{
	    DOPIX(2, yorgl, info.xorgo);
	    DOPIX(8, yorgol, info.xorgo);
	}
	if (!info.end.x || !info.end.y)
	{
	    mask = info.end.mask;
	    info.end = info.altend;
	}
	if (do360 && (arc->width == arc->height) && !(arc->width & 1))
	{
	    int xoffset = nlwidth;
	    int *yorghl = yorgl + (info.h * nlwidth);
	    int xorghp = info.xorg + info.h;
	    int xorghn = info.xorg - info.h;

	    while (1)
	    {
		PIXELATE(yorgl + yoffset, info.xorg + x);
		PIXELATE(yorgl + yoffset, info.xorg - x);
		PIXELATE(yorgol- yoffset, info.xorg - x);
		PIXELATE(yorgol - yoffset, info.xorg + x);
		if (a < 0)
		    break;
		PIXELATE(yorghl - xoffset, xorghp - y);
		PIXELATE(yorghl - xoffset, xorghn + y);
		PIXELATE(yorghl + xoffset, xorghn + y);
		PIXELATE(yorghl + xoffset, xorghp - y);
		xoffset += nlwidth;
		MIARCCIRCLESTEP(yoffset += nlwidth;);
	    }
	    x = info.w;
	    yoffset = info.h * nlwidth;
	}
	else if (do360)
	{
	    while (y < info.h || x < info.w)
	    {
		MIARCOCTANTSHIFT(dyoffset = nlwidth;);
		PIXELATE(yorgl + yoffset, info.xorg + x);
		PIXELATE(yorgl + yoffset, info.xorgo - x);
		PIXELATE(yorgol - yoffset, info.xorgo - x);
		PIXELATE(yorgol - yoffset, info.xorg + x);
		MIARCSTEP(yoffset += dyoffset;, yoffset += nlwidth;);
	    }
	}
	else
	{
	    while (y < info.h || x < info.w)
	    {
		MIARCOCTANTSHIFT(dyoffset = nlwidth;);
		if ((x == info.start.x) || (y == info.start.y))
		{
		    mask = info.start.mask;
		    info.start = info.altstart;
		}
		DOPIX(1, yorgl + yoffset, info.xorg + x);
		DOPIX(2, yorgl + yoffset, info.xorgo - x);
		DOPIX(4, yorgol - yoffset, info.xorgo - x);
		DOPIX(8, yorgol - yoffset, info.xorg + x);
		if ((x == info.end.x) || (y == info.end.y))
		{
		    mask = info.end.mask;
		    info.end = info.altend;
		}
		MIARCSTEP(yoffset += dyoffset;, yoffset += nlwidth;);
	    }
	}
	if ((x == info.start.x) || (y == info.start.y))
	    mask = info.start.mask;
	DOPIX(1, yorgl + yoffset, info.xorg + x);
	DOPIX(4, yorgol - yoffset, info.xorgo - x);
	if (arc->height & 1)
	{
	    DOPIX(2, yorgl + yoffset, info.xorgo - x);
	    DOPIX(8, yorgol - yoffset, info.xorg + x);
	}
    }
    else
    {
	int plane;
	int poff[32];

	for (plane = 0; plane < depth; plane++)
	{
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    poff[plane] = plane * dstpljmp;
	}

	switch(rop)
	{
	    case GXcopy:
		ZEROARC(fnCOPY);
		break;
	    case GXxor:
		ZEROARC(fnXOR);
		break;
	    case GXand:
		ZEROARC(fnAND);
		break;
	    case GXor:
		ZEROARC(fnOR);
		break;
	    case GXset:
		ZEROARC(fnSET);
		break;
	    case GXclear:
		ZEROARC(fnCLEAR);
		break;
	    case GXandReverse:
		ZEROARC(fnANDREVERSE);
		break;
	    case GXandInverted:
		ZEROARC(fnANDINVERTED);
		break;
	    case GXnor:
		ZEROARC(fnNOR);
		break;
	    case GXequiv:
		ZEROARC(fnEQUIV);
		break;
	    case GXinvert:
		ZEROARC(fnINVERT);
		break;
	    case GXorReverse:
		ZEROARC(fnORREVERSE);
		break;
	    case GXcopyInverted:
		ZEROARC(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		ZEROARC(fnORINVERTED);
		break;
	    case GXnand:
		ZEROARC(fnNAND);
		break;
	    default:
		break;
	}
    }
}

void
cfbZeroPolyArcSS(pDraw, pGC, narcs, parcs)
    DrawablePtr	pDraw;
    GCPtr	pGC;
    int		narcs;
    xArc	*parcs;
{
    register xArc *arc;
    register int i;
    BoxRec box;
    RegionPtr cclip;

    cclip = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip;
    for (arc = parcs, i = narcs; --i >= 0; arc++)
    {
	if (miCanZeroArc(arc))
	{
	    box.x1 = arc->x + pDraw->x;
	    box.y1 = arc->y + pDraw->y;
	    box.x2 = box.x1 + (int)arc->width + 1;
	    box.y2 = box.y1 + (int)arc->height + 1;
	    if ((*pDraw->pScreen->RectIn)(cclip, &box) == rgnIN)
		cfbZeroArcSS(pDraw, pGC, arc);
	    else
		miZeroPolyArc(pDraw, pGC, 1, arc);
	}
	else
	    miPolyArc(pDraw, pGC, 1, arc);
    }
}
