/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include <stdio.h>
#ifdef UniOSU
#include  <sys/sys9100.h>
#include  <sys/mman.h>
#include  <sys/devmap.h>
#else
#include  <om68k/sysomron.h>
#include  <sys/mman.h>
#include  <om68kdev/fbmap.h>
#endif

#include "omronFb.h" 
#include "omronFbFunc.h" 

#ifndef	MONO_ONLY
#include "X.h"
#include "Xproto.h"
#endif

#include "misc.h"
#include "scrnintstr.h"
#include "screenint.h"
#ifndef	MONO_ONLY
#include "resource.h"
#include "colormapst.h"
#endif

#include "mipointer.h"

static int dt_bm_depth;

static union palette *dt_bm_pal;
static int pal_fd;

static struct pal{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} paldata[16],palsave[16];

static omronDtBmScreenIndex;
static unsigned long omronDtBmGeneration = 0;
static ColormapPtr pInstalledMap;

extern int omronScreenIndex;	
extern unsigned long omronGeneration; 

extern int monitorResolution;

#ifndef MONO_ONLY
extern void omronDtBmInstallColormap();
extern void omronDtBmUnInstallColormap();
extern int  omronDtBmListInstalledColormaps();
extern void omronDtBmStoreColors();
#endif

omronDtBmCreate(omron_fb_info)
OmronFbInfoPtr omron_fb_info;
{
	DtBmMapPtr dt_bm_map;
	register int i,j;

	  
/* Set transparent Mapping.(MC68030) */

#ifdef UniOSU
	if (sys9100(S91TPTRE, 0x80, 0x3f, 0) < 0) {
		return FALSE;
	}
#else
	if (sysomron(S91TPTRE, 0x80, 0x3f, 0) < 0) {
		return FALSE;
	}
#endif

	dt_bm_map =(DtBmMapPtr)0xb1000000; 
	omron_fb_info->fb_map =(char *)dt_bm_map;

	omron_fb_info->cplane =(char *)0xb1080008;
	omron_fb_info->plane =(char *)0xb10c0008;


	sx_pselect_reg = &(dt_bm_map->pselect.reg);

	*sx_pselect_reg = (1<<omron_fb_info->fb_depth)-1;

	sx_refresh_reg = &(dt_bm_map->refresh.reg);


	for(j = 0;j < 16;j++) {
		sx_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[j]]);
		sx_conv_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[CONV_OP(j)]]);
		sx_trans_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[TRANS_OP(j)]]);
		sx_trans_conv_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[TRANS_CONV_OP(j)]]);
		sx_invert_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[INVERT_OP(j)]]);
		sx_const_src_op_cont0[j] =
		&(dt_bm_map->cplane.op_cont[gmwtosxop[CONST_OP(j)]]);
	}

	dt_bm_depth = omron_fb_info->fb_depth;	

	for(i = 0;i < omron_fb_info->fb_depth;i++) {
		for(j=0;j < 16;j++) {
			sx_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[j]]);
			sx_conv_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[CONV_OP(j)]]);
			sx_trans_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[TRANS_OP(j)]]);
			sx_trans_conv_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[TRANS_CONV_OP(j)]]);
			sx_invert_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[INVERT_OP(j)]]);
			sx_const_src_op_cont[i][j] =
			&(dt_bm_map->planes[i+1].op_cont[gmwtosxop[CONST_OP(j)]]);
		}
	}

	sx_plane_mask = (1 << dt_bm_depth) - 1;

	omronDtBmPalCreate();
	omronDtBmPalInit();

	if (omron_fb_info->fb_type == DT_PLASMA)
		*sx_refresh_reg = 0x100000;
	else
		*sx_refresh_reg = 0xff07f7e5;

}

omronDtBmSaveScreen(pScreen, on)
ScreenPtr     pScreen;
Bool          on;
{
	struct pal savepal[16]; 	
	register int i;

	if (on != SCREEN_SAVER_ON) {
		SetTimeSinceLastInputEvent();
		omronDtBmSetPal(palsave);
		return TRUE;
	}

	omronDtBmGetPal(palsave);

	for( i = 0 ; i < 16 ; i++)
	{
		savepal[i].red = 0x0;
		savepal[i].green = 0x0;
		savepal[i].blue = 0x0;
	}
	omronDtBmSetPal(savepal);
	
	return TRUE;
}

omronDtBmInit(index, pScreen, argc, argv)
    int           index;
    ScreenPtr     pScreen;
    int           argc;
    char          **argv;
{
	OmronFbInfoPtr pFbInfo;
	extern miPointerCursorFuncRec  omronPointerCursorFuncs;
	Bool omronDtBmCloseScreen();
	
	if (omronDtBmGeneration != serverGeneration)
	{
		if((omronDtBmScreenIndex = AllocateScreenPrivateIndex()) <0){
			Error("AllocateScreenPrivateIndex Error\n");
			return FALSE;
		}
		omronDtBmGeneration = serverGeneration;
	}

	pFbInfo = (OmronFbInfoPtr) pScreen->devPrivates[omronScreenIndex].ptr;


	if(pFbInfo->fb_depth == 1)
	{
		if ( !monitorResolution )
			monitorResolution = MONO_TV_RESOLUTION; 

		if(!mfbScreenInit(pScreen,(pointer)pFbInfo->plane,pFbInfo->scr_width,pFbInfo->scr_height,
				monitorResolution,monitorResolution,pFbInfo->fb_width)){
			Error("mfbScreenInit Error");
			return (FALSE);
		}

    		pScreen->whitePixel = 0;
    		pScreen->blackPixel = 1;

		miDCInitialize (pScreen, &omronPointerCursorFuncs);

		mfbCreateDefColormap(pScreen);

	}else {
#ifndef MONO_ONLY
		if ( !monitorResolution )
			monitorResolution = COLOR_TV_RESOLUTION; 

		if(!cfbScreenInit(pScreen,(pointer)pFbInfo->cplane,pFbInfo->scr_width,pFbInfo->scr_height,
				monitorResolution, monitorResolution,pFbInfo->fb_width, pFbInfo->fb_depth)) {
			Error("cfbScreenInit Error");
			return (FALSE);
		}
		
    		pScreen->InstallColormap = omronDtBmInstallColormap;
    		pScreen->UninstallColormap = omronDtBmUnInstallColormap;
    		pScreen->ListInstalledColormaps = omronDtBmListInstalledColormaps;
    		pScreen->StoreColors = omronDtBmStoreColors;
		miDCInitialize (pScreen, &omronPointerCursorFuncs);
		cfbCreateDefColormap(pScreen);
#endif
	}

	pScreen->SaveScreen = omronDtBmSaveScreen;
	pScreen->devPrivates[omronDtBmScreenIndex].ptr = (pointer) pScreen->CloseScreen;
	pScreen->CloseScreen = omronDtBmCloseScreen;
/* not draw logo
	omronDtBmSaveScreen(pScreen,SCREEN_SAVER_FORCER );
*/
	return TRUE;

}

omronDtBmCloseScreen(i,pScreen)
int		i;
ScreenPtr	pScreen;
{
  Bool ret;


	omronDtBmClearScreen(pScreen);
	pScreen->CloseScreen = (Bool (*)()) pScreen->devPrivates[omronDtBmScreenIndex].ptr;
	ret = (*pScreen->CloseScreen)(i, pScreen);
	omronDtBmSetPal(paldata);
	munmap(dt_bm_pal,sizeof(union palette));
	close(pal_fd);
	ResetConsoleMode();
	return(ret);
}

omronDtBmPalCreate()
{
	if ((pal_fd = open("/dev/palette",2)) < 0) {
		ErrorF("Can't open /dev/palette.\n");
		return FALSE;
	}

	if((dt_bm_pal = (union palette *)valloc(sizeof(union palette))) == (union palette *) NULL){
		return FALSE;	
	}

	if (mmap(dt_bm_pal, sizeof(union palette), PROT_WRITE, MAP_SHARED, pal_fd, 0) < 0) { 
		free(dt_bm_pal);
		return FALSE;
	}	

	if(ioctl(pal_fd, PLTIOCUND, 0) < 0)
		return FALSE;

	return TRUE; 
}


omronDtBmPalInit()
{
	omronDtBmGetPal(paldata);
}

omronDtBmGetPal(pal)
struct pal *pal;

{
	unsigned char    *palp;
	register	 int        i,j;

	/* save the CPU ROM palette setting */
	for (i = 0; i < 16; i++) {
		palp = &pal++->red;
		dt_bm_pal->reg.addr = i << 4;
		for (j = 0; j < 3; j++)
			*palp++ = dt_bm_pal->reg.coldata;	
	}
}

omronDtBmSetPal(pal)
struct pal *pal;
{
	register	int    i,j;
	unsigned char    *palp;

	/* restore palette data */
	for (i = 0; i < 16; i++) {
		palp = &pal++->red;
		dt_bm_pal->reg.addr = i << 4;
		for (j = 0; j < 3; j++)
			dt_bm_pal->reg.coldata = *palp++;
	}
}

omronDtBmPrintPal(pal)
struct pal *pal;
{
	register	int    i,j;
	unsigned char    *palp;

	/* restose palette data */
	for (i = 0; i < 16; i++) {
		ErrorF("\n index = %d\n",i);
		palp = &pal++->red;
		for (j = 0; j < 3; j++)
			ErrorF("%d ",*palp++ >> 4);
	}
}

omronDtBmClearScreen(pScreen)
ScreenPtr       pScreen;
{
	OmronFbInfoPtr pFbInfo;
	register int *j;
	register int nw,height;
	int	nwidth,nlwidth,nlwExtra;

	pFbInfo = (OmronFbInfoPtr) pScreen->devPrivates[omronScreenIndex].ptr;
	j = (int *)pFbInfo->cplane;
	nlwidth = (pFbInfo->fb_width)>>5;
	nwidth = (pScreen->width)>>5;
	nlwExtra = nlwidth - nwidth;
	height =pScreen->height;

	sx_set_operation_all( 3 /* GXcopy*/, ~0 );

	while(height--)
	{
		nw = nwidth; 
		while(nw--)
			*j++ = 0;
		j += nlwExtra; 
	}
}


#ifndef MONO_ONLY

void
omronDtBmStoreColors(pmap, ndef, pdefs)
ColormapPtr pmap;
int         ndef;
xColorItem  *pdefs;
{
	register unsigned char *palr = &(dt_bm_pal->reg.coldata);
	register unsigned char *palg = &(dt_bm_pal->reg.coldata);
	register unsigned char *palb = &(dt_bm_pal->reg.coldata);

	if (pmap != pInstalledMap)
		return;

	while (ndef--) {
		dt_bm_pal->reg.addr = pdefs->pixel << 4 ;
		*palr = pdefs->red >> 8;
		*palg = pdefs->green >> 8;
		*palb = pdefs->blue >> 8;
		pdefs++;
	}
}

void
omronDtBmInstallColormap(pcmap)
ColormapPtr     pcmap;
{
	int		entries = pcmap->pVisual->ColormapEntries;
	Pixel  		*ppix;
	xrgb		*prgb;
	xColorItem	*defs;
	register int 	i;
	 
	if (pcmap == pInstalledMap)
		return;

	ppix = (Pixel *)ALLOCATE_LOCAL( entries * sizeof(Pixel));
	prgb = (xrgb *)ALLOCATE_LOCAL( entries * sizeof(xrgb));
	defs = (xColorItem *)ALLOCATE_LOCAL(entries * sizeof(xColorItem));

	if (pInstalledMap)
		WalkTree( pcmap->pScreen, TellLostMap, &pInstalledMap->mid);
	pInstalledMap = pcmap;
	for ( i=0; i<entries; i++)
		ppix[i] = i;
	QueryColors( pcmap, entries, ppix, prgb);
	for ( i=0; i<entries; i++)
	{
		defs[i].pixel = ppix[i];
		defs[i].red = prgb[i].red;
		defs[i].green = prgb[i].green;
		defs[i].blue = prgb[i].blue;
		defs[i].flags =  DoRed|DoGreen|DoBlue;
	}
	omronDtBmStoreColors( pcmap, entries, defs);
	WalkTree(pcmap->pScreen, TellGainedMap, &pcmap->mid);
	DEALLOCATE_LOCAL(ppix);
	DEALLOCATE_LOCAL(prgb);
	DEALLOCATE_LOCAL(defs);
}
		
void
omronDtBmUnInstallColormap(pcmap)
ColormapPtr 	pcmap;
{
	 ColormapPtr defColormap;

	if ( pcmap != pInstalledMap)
		return;

	defColormap = (ColormapPtr) LookupIDByType( pcmap->pScreen->defColormap,
			RT_COLORMAP);

	if (defColormap == pInstalledMap)
		return;

	(*pcmap->pScreen->InstallColormap) (defColormap);
}	

int
omronDtBmListInstalledColormaps( pscr, pcmaps)
ScreenPtr 	pscr;
Colormap	*pcmaps;
{
	*pcmaps = pInstalledMap->mid;
	return 1;
} 
#endif
