/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

typedef struct _OmronFbInfo {
	int	fb_type;
	int	fb_width;
	int 	fb_height;
	int 	fb_depth;
	int	scr_width;
	int 	scr_height;
	char 	*cplane;
	char 	*plane;
	char	*fb_map;
} OmronFbInfo, *OmronFbInfoPtr;

typedef struct _OmronFbProc {
	int	(*CreateProc)();
	int	(*InitProc)();
} OmronFbProc;        


#define DT_BM 		0
#define DT_PLASMA 	1
#define DS_BM		2
#define FS_BM		3


#define SCREEN_WIDTH				1280
#define SCREEN_HEIGHT				1024

#define PLASMA_SCREEN_WIDTH			1024
#define PLASMA_SCREEN_HEIGHT			768

#define FB_WIDTH				2048
#define FB_HEIGHT				1024

#define COLOR_TV_RESOLUTION  			110 
#define MONO_TV_RESOLUTION			125   

struct bm_four_data {
	int			sd[4][1024][64];
};

struct bm_eight_data {
	int			sd[8][1024][64];
};

struct bm_cdata {
	int			sd[1][1024][64];
};

typedef struct dt_bm_fbmap {
	union {
		long	reg;
		char	pad2[0x40000];
	} refresh;
	union {
		long	reg;
		char	pad3[0x40000];
	} pselect;
	struct bm_cdata	cbmplane;
	struct bm_four_data	bmplane;
	struct bm_four_data	pad4;
	union fset {
		long	op_cont[16];
		char	pad[0x40000];
	} cplane;
	union fset	planes[4];
} *DtBmMapPtr;

union palette {
	struct {
		unsigned char    addr;
		unsigned char    coldata;
	} reg;
	char    pad[4096];
};

extern union palette *sx_palette;


struct ds_bm_map {
	union {
		long	op_cont[16];
		char	pad1[0x8000];
	} planes[7];
	union {
		struct {
			long	addr;
			long	data;
		} reg;
		char	pad2[0x4000];
	} acrtc;
	union {
		long	reg;
		char	pad3[0x1000];
	} pselect;
	union {
		long	reg;
		char	pad4[0x2000];
	} refresh;
	union {
		struct {
			long	addr;
			long	control;
			long	coldata;
			long	ovcdata;
		} reg;
		char	pad5[0x1000];
	} palette;
};


extern char gmwtosxop[];


#define CONV_OP(op)             (conv_op_table[op])
#define INVERT_OP(op)           (invert_op_table[op])
#define CONST_OP(op)            (const_src_op_table[op])
#define TRANS_OP(op)            (((op)&0x3)+0x4)
#define TRANS_CONV_OP(op)       (trans_conv_op_table[op])
#define	MASK_OP(op)		((op)&0xf)


extern long		*sx_op_cont0[16];
extern long		*sx_op_cont[8][16];
extern long		*sx_conv_op_cont0[16];
extern long		*sx_conv_op_cont[8][16];
extern long		*sx_trans_op_cont0[16];
extern long		*sx_trans_op_cont[8][16];
extern long		*sx_trans_conv_op_cont0[16];
extern long		*sx_trans_conv_op_cont[8][16];
extern long		*sx_const_src_op_cont0[16];
extern long		*sx_const_src_op_cont[8][16];
extern long		*sx_invert_op_cont0[16];
extern long		*sx_invert_op_cont[8][16];


extern char 		conv_op_table[];
extern char		trans_conv_op_table[];
extern char		const_src_op_table[];
extern char		invert_op_table[];

extern long		*sx_pselect_reg;
extern long		*sx_refresh_reg;

extern long		sx_plane_mask;
