/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

/*
**	omronFbFunc.h
*/
#ifndef	TRANS_OP
#include "omronFb.h"
#endif

#define	sx_set_scroll(x,y)		\
	*sx_refresh_reg = (((x-8) & 0xff)<<16)|((y-26) & 0x3ff)

#define	spb_address4(sxpb,x,y)	((Bytex4 *)\
				(((unsigned long)((sxpb)->spb_data))+\
				(y<<8)+((x>>3) & 0xfffffffc)))
#define	spb_address2(sxpb,x,y)	((Bytex2 *)\
				(((unsigned long)((sxpb)->spb_data))+\
				(y<<8)+((x>>3) & 0xfffffffe)))

#define	spb_caddress4(sxpb,x,y)	((Bytex4 *)\
				(((unsigned long)((sxpb)->spb_cdata))+\
				(y<<8)+((x>>3) & 0xfffffffc)))
#define	spb_caddress2(sxpb,x,y)	((Bytex2 *)\
				(((unsigned long)((sxpb)->spb_cdata))+\
				(y<<8)+((x>>3) & 0xfffffffe)))


/*
 *	omron monochrome frame buffer 
 */ 

#define	sx1_check_operation(op,mask)		\
	if(op == GXnoop)	return;		\
	*sx_op_cont0[op] = (long)(mask);

#define	sx1_check_transparent(op,mask)			\
	if((op = TRANS_OP(op)) == GXnoop)	return;	\
	*sx_op_cont0[op] = (long)(mask);

/*
 *	omron color frame buffer
 */

#define	sx_check_operation(op,mask,color,pmask)		\
	switch(op = MASK_OP(op)) {\
	case GXnoop:\
		return;\
	case GXandInverted:\
	case GXxor:\
	case GXor:\
		if((pmask &= color) == 0) return;\
		sx_set_operation_all(op,mask);\
		break;\
	case GXclear:\
	case GXand:\
	case GXandReverse:\
	case GXcopy:\
	case GXnor:\
	case GXequiv:\
	case GXinvert:\
	case GXorReverse:\
	case GXcopyInverted:\
	case GXorInverted:\
	case GXnand:\
	case GXset:\
		sx_set_operation(op,mask,color);\
	}

#define	sx_check_transparent(op,mask,color,pmask) \
	switch(op = MASK_OP(op)){\
	case GXnoop:\
		return;\
	case GXandInverted:\
	case GXxor:\
	case GXor:\
		if((pmask &= color) == 0) return;\
		sx_set_operation_all(TRANS_OP(op),mask);\
		break;\
	case GXand:\
	case GXequiv:\
	case GXorInverted:\
		if((pmask &= ~color) == 0) return;\
		sx_set_operation_all(TRANS_CONV_OP(op),mask);\
		break;\
	case GXclear:\
	case GXandReverse:\
	case GXcopy:\
	case GXnor:\
	case GXinvert:\
	case GXorReverse:\
	case GXcopyInverted:\
	case GXnand:\
	case GXset:\
		sx_set_transparent(op,mask,color);\
		break;\
	}

#define sx_set_op(op, mask)					\
	*sx_op_cont0[op] = (long)(mask);

#define	sx_set_operation(op,mask,color)				\
	sx_plane_select(color);					\
	*sx_op_cont0[op] = (long)(mask);			\
	sx_plane_select(~color);				\
	*sx_conv_op_cont0[op] = (long)(mask);

#define	sx_set_transparent(op,mask,color)			\
	sx_plane_select(color);					\
	*sx_trans_op_cont0[op] = (long)(mask);			\
	sx_plane_select(~color);				\
	*sx_trans_conv_op_cont0[op] = (long)(mask);

#define	sx_plane_select(i)					\
	*sx_pselect_reg = (long)(i);

#define	sx_set_operation_all(op,mask)				\
	*sx_pselect_reg = (long)(sx_plane_mask);		\
	*sx_op_cont0[op] = (long)(mask);
