/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include <stdio.h>
#ifdef	UniOSU
#include <sys/param.h>
#include "X.h"
#include "osdep.h"
#else
#include "X.h"
#endif

#include "misc.h"
#include "input.h"

int lastEventTime = 0;

extern int omronSigIO;

#if	defined(UniOSU) || defined(NO_SIGIO)
extern	long 	omronKeyboardMask[];
extern  long	omronMouseMask[];
extern	long	devicesReadable[];
#endif

extern int screenIsSaved;


void
ProcessInputEvents()
{
	DevicePtr               pPointer;
	DevicePtr               pKeyboard;
	int NeedRetry = TRUE;
	int mouse_event = FALSE;
	int keyboard_event = FALSE;

	omronSigIO = 0;
	pPointer = LookupPointerDevice();
	pKeyboard = LookupKeyboardDevice();

#if	defined(UniOSU) || defined(NO_SIGIO)
	if(omronMouseMask[0] & devicesReadable[0]) {
		while(NeedRetry){
			mouse_event =
				omronProcessMouseEvent(pPointer,&NeedRetry);	
		}
	}
#else
	while(NeedRetry){
		mouse_event=omronProcessMouseEvent(pPointer,&NeedRetry);	
	}
#endif

#if	defined(UniOSU) || defined(NO_SIGIO)
	if(omronKeyboardMask[0] & devicesReadable[0]) {
		keyboard_event=omronProcessKbdEvent(pKeyboard);
	}
#else
	keyboard_event=omronProcessKbdEvent(pKeyboard);
#endif

	if(!(mouse_event | keyboard_event))
		return;

	if (screenIsSaved == SCREEN_SAVER_ON) {
		SaveScreens(SCREEN_SAVER_OFF, ScreenSaverReset);
	}
}

int
TimeSinceLastInputEvent()
{
	int now;
	
	now = GetTimeInMillis();

	if (lastEventTime == 0) {
		lastEventTime = now;
	}
	return(now - lastEventTime);
}

SetTimeSinceLastInputEvent()
{
	lastEventTime = GetTimeInMillis();
}

		
		

