/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#ifdef	UniOSU
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/kbms.h>
#include <sys/param.h>
#else
#ifdef NO_SIGIO
#include <sys/param.h>
#endif
#include <om68kdev/kbms.h>
#endif


#include "X.h"
#include "Xmd.h"
#define NEED_EVENTS
#include "Xproto.h"

#include "input.h"

#include "mipointer.h"
#include "scrnintstr.h"
#include "inputstr.h"

#if	defined(UniOSU) || defined(NO_SIGIO)
#include "osdep.h"
#endif

#include "omronMouse.h"

static long omronEventTime();
static Bool omronCursorOffScreen();
static void omronCrossScreen();
extern void miPointerQueueEvent();

static int omronGetMotionEvents();

static void omronMouseControl(); 

extern int lastEventTime;


int mousefd = -1;
#if	defined(UniOSU) || defined(NO_SIGIO)
long	omronMouseMask[mskcnt];
#endif

static int delta_x; 
static int delta_y; 
static int button_state=7;

static int MouseMoved = FALSE;

miPointerCursorFuncRec omronPointerCursorFuncs = {
	omronEventTime,
	omronCursorOffScreen,
	omronCrossScreen,
	miPointerQueueEvent,
};

int ActiveZaphod;

extern int errno;

int
omronMouseProc(pMouse,what)
DevicePtr 	pMouse;
int		what;
{
	BYTE            map[4];

	switch(what) {
	case DEVICE_INIT:
		omronMouseInit();
#if	defined(UniOSU) || defined(NO_SIGIO)
		CLEARBITS(omronMouseMask);
#endif
		map[1] = 1;
		map[2] = 2;
		map[3] = 3;
		InitPointerDeviceStruct(
		pMouse,map,3,omronGetMotionEvents,omronMouseControl,0);
		break;	
	case DEVICE_ON:
		AddEnabledDevice (mousefd);
#if	defined(UniOSU) || defined(NO_SIGIO)
		BITSET(omronMouseMask,mousefd);
#endif
		pMouse->on = TRUE;
		break;
	case DEVICE_OFF:
		RemoveEnabledDevice(mousefd);
#if	defined(UniOSU) || defined(NO_SIGIO)
		BITCLEAR(omronMouseMask,mousefd);
#endif
		pMouse->on = FALSE;
		break;
	case DEVICE_CLOSE:
		close(mousefd);
		break;
	}
	return (Success);
}


omronMouseInit()
{
#ifdef	UniOSU
	struct mssetlimt limit;
#endif	/* UniOSU */

	if ((mousefd = open("/dev/mouse",O_RDONLY)) == -1) {
		Error("Can't open mouse device.");
	}

#if	defined(UniOSU) || defined(NO_SIGIO)
	{ 
		int arg = 1;
		ioctl (mousefd, FIONBIO, &arg);
	}
#else
	if (fcntl (mousefd, F_SETFL, (FNDELAY|FASYNC)) < 0
	    || fcntl(mousefd, F_SETOWN, getpid()) < 0) {
		ErrorF("Can't set up mouse on fd %d.",mousefd);
	}
#endif

/* ƥ५ɽˤ */

	if (ioctl(mousefd,MSSETCURS,8) < 0) {
		Error("mouse ioctl MSSETCURS fault.");
	}

/* ɸǡΥǥ륿ͤǡ */

	if(ioctl(mousefd, MSSETMODE,1) < 0) {
		Error("mouse ioctl MSSEMODE fault.");

	}
#ifdef	UniOSU	/* OS BUG ?? */
/* ³̵ˤ롣*/

	limit.mode = 1;
	if(ioctl(mousefd, MSSETLIMT,&limit) < 0) {
		Error("mouse ioctl MSSETLMT fault.");
	}
#endif	/* UniOSU */

}


#define MAXEVENTS    1024

	
omronProcessMouseEvent(pMouse,Retry)
DevicePtr	pMouse;
int   		*Retry;
{
	struct msdgeta msdata;
	struct msdata data[MAXEVENTS];
	register int i;
	

/* ޥǡХåեƬǡ */

	msdata.mode = 1;
	msdata.count = MAXEVENTS;
	msdata.msdatap = data;

/* ޥǡ */

	if (ioctl(mousefd,MSDGETA,&msdata) < 0) {
		return FALSE;
	}

	for(i = 0;i < msdata.retval;i++) {
		omronSetMouseEvent(pMouse,data+i);
	}

	if(MouseMoved)
	{
		miPointerDeltaCursor (screenInfo.screens[0],delta_x, delta_y,TRUE);
		MouseMoved = FALSE;
	}
		
/* MAXEVENTS ʬǡ줿硢
 * ˡޥǡХåե˥ǡĤäƤ
 * ǽ롣
 */
	if ( !( *Retry = (msdata.retval == MAXEVENTS) ))
	{	
		delta_x = delta_y = 0;
	}
	return TRUE;
}

omronSetMouseEvent(pMouse,data)
DevicePtr       pMouse;
struct msdata 	*data;
{
	xEvent	xE;
	register int i;
	short MouseAccelerate();

	lastEventTime = GetTimeInMillis();
	xE.u.keyButtonPointer.time = lastEventTime;
	switch(data->type) {
	case COORDEVNT:
		delta_x +=MouseAccelerate(pMouse, data->event.coordinate.X_coord);
		delta_y +=MouseAccelerate(pMouse, data->event.coordinate.Y_coord);
		MouseMoved = TRUE;
		break;
	case BUTONEVNT:
		i = ((data->event.button.L_button == 0) << 2) |
		    ((data->event.button.M_button == 0) << 1) |
		    (data->event.button.R_button == 0);
		button_state = (((button_state & ~i) & 0x7) << 6) |
			    (((~button_state & i) & 0x7) << 3) |
			    (i & 0x7);

		miPointerPosition (screenInfo.screens[0],
			   &xE.u.keyButtonPointer.rootX,
			   &xE.u.keyButtonPointer.rootY);

		if (BUTTON_PRESSED(button_state)) {
			xE.u.u.type = ButtonPress;
			if (LEFT_PRESSED(button_state)) {
				xE.u.u.detail = 1; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
			if (RIGHT_PRESSED(button_state)) {
				xE.u.u.detail = 3; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
			if (MIDDLE_PRESSED(button_state)) {
				xE.u.u.detail = 2; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
		}
		if (BUTTON_RELEASED(button_state)) {
			xE.u.u.type = ButtonRelease;
			if (LEFT_RELEASED(button_state)) {
				xE.u.u.detail = 1; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
			if (RIGHT_RELEASED(button_state)) {
				xE.u.u.detail = 3; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
			if (MIDDLE_RELEASED(button_state)) {
				xE.u.u.detail = 2; 
				(* pMouse->processInputProc) (&xE, pMouse, 1);
			}
		}
		break;
	}
}

Bool
omronCursorOffScreen (pScreen, x, y)
    ScreenPtr	*pScreen;
    int		*x, *y;
{

	if (ActiveZaphod)
	{
		if (*x < 0)
			*x += (*pScreen)->width;
		if (*y < 0)
			*y += (*pScreen)->height;
	}
	return FALSE;
}

static void
omronCrossScreen(pScreen,x,y)
ScreenPtr	pScreen;
int		x;
int		y;
{

}

static long
omronEventTime()
{
	return(GetTimeInMillis());
}


static short
MouseAccelerate (pMouse, delta)
    DevicePtr	  pMouse;
    int	    	  delta;
{
    register int  sgn = sign(delta);
    register PtrCtrl *pCtrl;

    delta = abs(delta);
    pCtrl = &((DeviceIntPtr) pMouse)->ptrfeed->ctrl;

    if (delta > pCtrl->threshold) {
	return ((short) (sgn * (pCtrl->threshold +
				((delta - pCtrl->threshold) * pCtrl->num) /
				pCtrl->den)));
    } else {
	return ((short) (sgn * delta));
    }
}

omronGetMotionEvents()
{
	return FALSE;
}

static void
omronMouseControl()
{
}
